// SPONGEBOB SQUAREPANTS

// Constants
local HYDRATION_TIME = 10*TICRATE // Max Hydration Time
local WHIRLPOOL_TIME = 8*TICRATE // Max Whirlpool Time
local STRING_LENGTH = 32 // Balloon String Length

// Console Variables
local cv_powerups = CV_FindVar("ss_powerups")
local cv_pickups = CV_FindVar("ss_pickups")
local cv_keeppowerups = CV_FindVar("ss_keeppowerups")
local cv_deadlylava = CV_FindVar("ss_deadlylava")
local cv_supersponge_jingles = CV_FindVar("ss_jingles")
local cv_taunts = CV_FindVar("ss_taunts")
local cv_victorytaunts = CV_FindVar("ss_victorytaunts")
local cv_footsteps = CV_FindVar("ss_footsteps")

// Overlay SPR2 table for pants and blower.
// Format for each entry is: [INDEX] = {SPR_NUMBER, FRAME_LIMIT}
local overlay_spr2_table = {
	["pants"] = {
		[SPR2_STND] = {1, 0},
		[SPR2_WAIT] = {1, 0},
		[SPR2_WALK] = {2, 6},
		[SPR2_JUMP] = {1, 0},
		[SPR2_ROLL] = {3, 7},
		[SPR2_SPNG] = {4, 0},
		[SPR2_RUN_] = {5, 15},
		[SPR2_GASP] = {6, 0},
		[SPR2_PAIN] = {7, 0},
		[SPR2_STUN] = {8, 0},
		[SPR2_DEAD] = {9, 0},
		[SPR2_DRWN] = {10, 8},
		[SPR2_EDGE] = {11, 6},
		[SPR2_FALL] = {12, 0},
		[SPR2_RIDE] = {13, 0},
		[SPR2_TRNS] = {14, 6},
		[SPR2_SKID] = {15, 0},
		[SPR2_NSTD] = {16, 0},
		[SPR2_NFLT] = {17, 0},
		[SPR2_NFLY] = {18, 0},
		[SPR2_NDRL] = {19, 7},
		[SPR2_NPUL] = {20, 0},
		[SPR2_NSTN] = {21, 0},
		[SPR2_NATK] = {3, 8}, 
		[SPR2_FLT_] = {22, 0},
		[SPR2_FRUN] = {23, 0},
		[SPR2_SWIM] = {24, 3},
		[SPR2_GLID] = {25, 0},
		[SPR2_CLNG] = {26, 0},
		[SPR2_CLMB] = {27, 3},
		[SPR2_MLEE] = {28, 3},
		[SPR2_MLEL] = {29, 0},
		[SPR2_FIRE] = {30, 7},
		[SPR2_BNCE] = {31, 7},
		[SPR2_JUMP] = {32, 0},
		[SPR2_CNT1] = {33, 0},
		[SPR2_JNET] = {34, 3},
		[SPR2_BWND] = {35, 5},
		[SPR2_OOF_] = {36, 0},
		[SPR2_TWIN] = {37, 8},
		[SPR2_F2RE] = {38, 7},
		[SPR2_MZAP] = {39, 0},
		[SPR2_W3LK] = {40, 6},
		[SPR2_FKIK] = {41, 7}
	},
	["blower"] = {
		[SPR2_STND] = {1, 0},
		[SPR2_WAIT] = {1, 0},
		[SPR2_JUMP] = {1, 0},
		[SPR2_ROLL] = {3, 7},
		[SPR2_SPNG] = {4, 0},
		[SPR2_GASP] = {6, 0},
		[SPR2_PAIN] = {7, 0},
		[SPR2_STUN] = {8, 0},
		[SPR2_DEAD] = {9, 0},
		[SPR2_DRWN] = {10, 8},
		[SPR2_EDGE] = {11, 6},
		[SPR2_FALL] = {12, 0},
		[SPR2_RIDE] = {13, 0},
		[SPR2_TRNS] = {14, 6},
		[SPR2_SKID] = {15, 0},
		[SPR2_NSTD] = {16, 0},
		[SPR2_NFLT] = {17, 0},
		[SPR2_NFLY] = {18, 0},
		[SPR2_NDRL] = {19, 7},
		[SPR2_NPUL] = {20, 0},
		[SPR2_NSTN] = {21, 0},
		[SPR2_NATK] = {3, 8}, 
		[SPR2_FLT_] = {22, 0},
		[SPR2_FRUN] = {23, 0},
		[SPR2_SWIM] = {24, 3},
		[SPR2_GLID] = {25, 0},
		[SPR2_CLNG] = {26, 0},
		[SPR2_CLMB] = {27, 3},
		[SPR2_MLEE] = {28, 3},
		[SPR2_MLEL] = {29, 0},
		[SPR2_FIRE] = {30, 7},
		[SPR2_BNCE] = {31, 7},
		[SPR2_JUMP] = {32, 0},
		[SPR2_CNT1] = {33, 0},
		[SPR2_OOF_] = {36, 0},
		[SPR2_TWIN] = {37, 8},
		[SPR2_F2RE] = {38, 7},
		[SPR2_MZAP] = {39, 0},
		[SPR2_W3LK] = {40, 6},
		[SPR2_FKIK] = {41, 7}
	},
	["helmet"] = {
		[SPR2_STND] = {1, 0},
		[SPR2_WAIT] = {1, 0},
		[SPR2_WALK] = {2, 6},
		[SPR2_JUMP] = {1, 0},
		[SPR2_ROLL] = {3, 7},
		[SPR2_SPNG] = {4, 0},
		[SPR2_RUN_] = {5, 15},
		[SPR2_GASP] = {6, 0},
		[SPR2_PAIN] = {7, 0},
		[SPR2_STUN] = {8, 0},
		[SPR2_DEAD] = {9, 0},
		[SPR2_DRWN] = {10, 8},
		[SPR2_EDGE] = {11, 6},
		[SPR2_FALL] = {12, 0},
		[SPR2_RIDE] = {13, 0},
		[SPR2_TRNS] = {14, 6},
		[SPR2_SKID] = {15, 0},
		[SPR2_NSTD] = {16, 0},
		[SPR2_NFLT] = {17, 0},
		[SPR2_NFLY] = {18, 0},
		[SPR2_NDRL] = {19, 7},
		[SPR2_NPUL] = {20, 0},
		[SPR2_NSTN] = {21, 0},
		[SPR2_NATK] = {3, 8}, 
		[SPR2_FLT_] = {22, 0},
		[SPR2_FRUN] = {23, 0},
		[SPR2_SWIM] = {24, 3},
		[SPR2_GLID] = {25, 0},
		[SPR2_CLNG] = {26, 0},
		[SPR2_CLMB] = {27, 3},
		[SPR2_MLEE] = {28, 3},
		[SPR2_MLEL] = {29, 0},
		[SPR2_FIRE] = {30, 7},
		[SPR2_BNCE] = {31, 7},
		[SPR2_JUMP] = {32, 0},
		[SPR2_CNT1] = {33, 0},
		[SPR2_JNET] = {34, 3},
		[SPR2_BWND] = {35, 5},
		[SPR2_OOF_] = {36, 0},
		[SPR2_TWIN] = {37, 8},
		[SPR2_F2RE] = {38, 7},
		[SPR2_MZAP] = {39, 0},
		[SPR2_W3LK] = {40, 6},
		[SPR2_FKIK] = {41, 0}
	}
}

// Jingle Replacement Table
local supersponge_jingles = {
	["_super"] = "merman",
	["_shoes"] = "qikstr",
	["_inv"] = "ssinv",
	["_gover"] = "ssgovr",
	["_creds"] = "sscred",
	["_1up"] = "sb1up",
	["_clear"] = "sbclr"
}

// Spongebob State Table
local spongestates = {
	["karate"] = {
		S_PLAY_SSCHOP,
		S_PLAY_SSCHOP2,
		S_PLAY_SSCHOP3,
		S_PLAY_SSCHOP4,
		S_PLAY_SSCHOP5
	},
	["fishing"] = {
		S_PLAY_SSNET,
		S_PLAY_SSNET2,
		S_PLAY_SSNET3,
		S_PLAY_SSNET4
	},
	["blowing"] = {
		S_PLAY_SSWAND,
		S_PLAY_SSWAND2,
		S_PLAY_SSWAND3,
		S_PLAY_SSWAND4
	},
	["shooting"] = {
		S_PLAY_SSGUN,
		S_PLAY_SSGUN2,
		S_PLAY_SSGUN3,
		S_PLAY_SSGUN4,
		S_PLAY_SSF2RE,
		S_PLAY_SSF2RE2,
		S_PLAY_SSF2RE3,
		S_PLAY_SSF2RE4
	}
}


//////////////////////////////////////////
//          Search Functions           //
////////////////////////////////////////


// P_FindPowerup
// The blockmap function used in searching for powerups.
local function P_FindPowerup(mo, mo2) 
	
	local dist
	
	if (mo2.type != MT_SUPERSPONGE_POWERUP) then
		return nil
	end
	
	dist = P_AproxDistance(mo2.x - mo.x, mo2.y - mo.y)
	
	// If we're at the same height and the powerup is within range, then we are close
	if (mo2.z <= mo.z + mo.height and mo.z <= mo2.z + mo.height and dist <= USERANGE/2) then
		return true
	else
		return nil
	end
end

// P_IsNearPowerup
// Tries to check if player is nearby a powerup
local function P_IsNearPowerup(player)

	local near
	local found
	
	found = searchBlockmap("objects", P_FindPowerup, player.mo)
	
	// We're near a powerup!
	if (found == false) then
		near = true
	else
		near = false
	end
	
	return near
end

// P_FindNearestPlayer
// Tries to find the nearest player from mobj
local function P_FindNearestPlayer(mobj, allaround, dist)

	local player
	local an
	
	for player in players.iterate() do
	
		if ((netgame or multiplayer) and player.spectator)
			continue // spectating
		end

		if (player.pflags & PF_INVIS)
			continue // ignore notarget
		end

		if not (player.mo and player.mo.valid and player.mo != mobj)
			continue // not valid or player is us
		end

		if (player.mo.health <= 0)
			continue // dead
		end

		if (player.bot == BOT_2PAI or player.bot == BOT_2PHUMAN)
			continue // ignore followbots
		end

		if (player.quittime)
			continue // Ignore uncontrolled bodies
		end

		if (dist > 0 and P_AproxDistance(P_AproxDistance(player.mo.x - mobj.x, player.mo.y - mobj.y), player.mo.z - mobj.z) > dist)
			continue // Too far away
		end

		if not (allaround)
			an = R_PointToAngle2(mobj.x, mobj.y, player.mo.x, player.mo.y) - mobj.angle
			if (an > ANGLE_90 and an < ANGLE_270)
				dist = P_AproxDistance(player.mo.x - mobj.x, player.mo.y - mobj.y)
				// if real close, react anyway
				if (dist > FixedMul(MELEERANGE, mobj.scale))
					continue // behind back
				end
			end
		end

		if not (P_CheckSight(mobj, player.mo))
			continue // out of sight
		end
		
		return player
	end

	return nil
end


//////////////////////////////////////////
//          Boolean Functions          //
////////////////////////////////////////


local function P_IsMovementLocked(player)
	if (P_PlayerInPain(player))
	or (player.playerstate == PST_DEAD)
	or (player.pflags & PF_SLIDING)
	or (player.powers[pw_carry] > 0)
	or (player.powers[pw_nocontrol] != (player.powers[pw_nocontrol] & 32768))
	or (player.exiting > 0)
	or (player.mo.state == S_PLAY_SPRING and player.ssvars.springtimer < 2)
		return true
	else
		return false
	end
end

local function P_IsChopping(player)

	local tbl = spongestates["karate"]

	for i = 1, #tbl, 1 do
	
		if (player.mo.state != tbl[i])
			continue
		end
		
		return true
	end
	
	return false
end

local function P_IsButtBouncing(player)
	return (player.ssvars and player.ssvars.buttbounce or false)
end

local function P_IsReefBlowing(player)
	return (player.ssvars and player.ssvars.blower.status == RB_STATUS_ON or false)
end

local function P_IsBlowerActive(player)
	return (player.powers[pw_super] <= 0 and player.ssvars.blower.status > 0)
end

local function P_IsNetFull(player)
	return (P_GetNetCount(player) >= supersponge_powerup_info[SS_POWERUP_NET].maxammo)
end

local function P_IsJellyfishing(player)

	local tbl = spongestates["fishing"]

	for i = 1, #tbl, 1 do
	
		if (player.mo.state != tbl[i])
			continue
		end
		
		return true
	end
	
	return false
end

local function P_IsBlowingBubbles(player)

	local tbl = spongestates["blowing"]

	for i = 1, #tbl, 1 do
	
		if (player.mo.state != tbl[i])
			continue
		end
		
		return true
	end
	
	return false
end

local function P_IsShooting(player)

	local tbl = spongestates["shooting"]

	for i = 1, #tbl, 1 do
	
		if (player.mo.state != tbl[i])
			continue
		end
		
		return true
	end
	
	return false
end

local function P_IsZapping(player)
	return (player.ssvars.zapping)
end

local function P_IsWhirlpooling(player)
	return (player.ssvars and player.ssvars.whirlpooling and player.ssvars.whirlpooltimer < WHIRLPOOL_TIME or false)
end

local function P_IsBlowerFull(player)
	return (P_GetBlowerCount(player) >= supersponge_powerup_info[SS_POWERUP_BLOWER].maxammo)
end

local function P_CanSpongeBounce(sponge)
	if P_IsMovementLocked(sponge)
	or P_PlayerTouchingSectorSpecial(sponge, 4, 5)	
	or P_IsButtBouncing(sponge)
	or P_IsChopping(sponge)
	or P_IsJellyfishing(sponge)
	or (P_IsPowerupActive(sponge, SS_POWERUP_BLOWER) and sponge.powers[pw_super] <= 0)
		return false
	else
		return true
	end
end

local function P_CanSpongeChop(sponge)

	// Performing an action.
	if P_IsMovementLocked(sponge)
	or P_IsChopping(sponge)
	or P_IsButtBouncing(sponge)
	or P_IsBlowerActive(sponge)
	or P_IsJellyfishing(sponge)
	or P_IsWhirlpooling(sponge) then
		return false
	end
	
	// The player already pressed SPIN.
	if (sponge.pflags & PF_SPINDOWN) then
		return false
	end
	
	// The melee timer is active.
	if (sponge.ssvars.meleetimer > 0) then
		return false
	end
	
	return true
end

local function P_CanSpongeVacuum(sponge)

	// Performing an action.
	if P_IsMovementLocked(sponge)
	or P_IsChopping(sponge)
	or P_IsButtBouncing(sponge)
	or P_IsJellyfishing(sponge)
	or P_IsWhirlpooling(sponge) then
		return false
	end
	
	// The blower is full.
	if P_IsBlowerFull(sponge) then
		return false
	end
	
	// The blower is stuck.
	if (sponge.ssvars.blower.status >= RB_STATUS_STUCK) then
		return false
	end
	
	return true
end


local function P_CanSpongeJellyfish(sponge)

	// Performing an action.
	if P_IsMovementLocked(sponge)
	or P_IsChopping(sponge)
	or P_IsButtBouncing(sponge)
	or P_IsBlowerActive(sponge)
	or P_IsJellyfishing(sponge)
	or P_IsWhirlpooling(sponge) then
		return false
	end
	
	// The net is full.
	if P_IsNetFull(sponge) then
		return false
	end
	
	// The melee timer is active.
	if (sponge.ssvars.meleetimer > 0) then
		return false
	end
	
	return true
end

local function P_CanSpongeToss(sponge)
	
	// Performing an action.
	if P_IsMovementLocked(sponge)
	or P_IsButtBouncing(sponge)
	or P_IsChopping(sponge)
	or P_IsBlowerActive(sponge)
	or P_IsJellyfishing(sponge)
	or P_IsShooting(sponge)
	or P_IsWhirlpooling(sponge) then
		return false
	end
	
	// Only swap near powerups.
	if P_IsNearPowerup(sponge) then
		return false
	end

	// Already tossing.
	if (sponge.tossdelay > 0) then
		return false
	end

	return true
end

local function P_CanPieToss(sponge)

	// Performing an action.
	if P_IsMovementLocked(sponge)
	or P_IsButtBouncing(sponge)
	or P_IsChopping(sponge)
	or P_IsBlowerActive(sponge)
	or P_IsJellyfishing(sponge)
	or P_IsShooting(sponge)
	or P_IsWhirlpooling(sponge)
		return false
	end
		
	// The pie is not active.
	if (sponge.ssvars.powerups[SS_POWERUP_PIE] <= 0) then
		return false
	end
	
	// Already tossing.
	if (sponge.tossdelay > 0) then
		return false
	end
	
	return true
end

local function P_CanShootJellyfish(player)

	// Performing an action.
	if P_IsMovementLocked(player)
	or P_IsButtBouncing(player)
	or P_IsChopping(player)
	or P_IsBlowerActive(player)
	or P_IsJellyfishing(player)
	or P_IsShooting(player)
	or P_IsWhirlpooling(player) then
		return false
	end
	
	// Out of ammo.
	if (player.powers[pw_super] <= 0 and player.ssvars.ammo["jellyfish"] <= 0) then
		return false
	end
	
	// Shooting cooldown is active.
	if (player.ssvars.shoottimer > 0) then
		return false
	end
	
	return true
end

local function P_CanBlowBubbles(sponge)

	// Performing an action.
	if P_IsMovementLocked(sponge)
	or P_IsButtBouncing(sponge)
	or P_IsChopping(sponge)
	or P_IsBlowerActive(sponge)
	or P_IsJellyfishing(sponge)
	or P_IsWhirlpooling(sponge)
	or P_IsBlowingBubbles(sponge) then
		return false
	end
	
	// Ran out of ammo.
	if (sponge.ssvars.ammo["bubbles"] <= 0) then
		return false
	end
	
	// Shooting cooldown is active.
	if (sponge.ssvars.shoottimer > 0) then
		return false
	end
	
	return true
end

local function P_CanWhirlpool(player)

	// Performing an action
	if P_IsMovementLocked(player)
	or P_IsButtBouncing(player)
	or P_IsChopping(player)
	or P_IsJellyfishing(player)
	or P_IsBlowerActive(player)
	or P_IsWhirlpooling(player) then
		return false
	end
	
	// The Raging Whirlpool has finished rising.
	if (player.ssvars.whirlpooltimer >= WHIRLPOOL_TIME) then
		return false
	end
	
	return true
end

local function P_IsInJumpState(player)
	return (not P_IsObjectOnGround(player.mo)
	and (player.mo.state == S_PLAY_JUMP)
	or (player.mo.state == S_PLAY_ROLL)
	or (player.mo.state == S_PLAY_FALL)
	or (player.mo.state == S_PLAY_TWINSPIN)
	or (player.mo.state == S_PLAY_SPRING))
end


//////////////////////////////////////////
//           Spawn Functions           //
////////////////////////////////////////


// SB_SpawnBalloon
local function SB_SpawnBalloon(sponge)
	// Spawn balloon thing
	local balloon = P_SpawnMobj(sponge.mo.x, 
								sponge.mo.y, 
								sponge.mo.z, 
								MT_SUPERSPONGE_BALLOON)

	// target player
	balloon.target = sponge.mo
		
	// Set balloon thing
	sponge.ssvars.balloon = balloon
end

// SB_SpawnBlowerOverlay
local function SB_SpawnBlowerOverlay(sponge)

	local cvar
	local blower
	local hose
	
	if not P_IsSuperSponge(sponge.mo.skin) then
		return
	end

	// Spawn the blower overlay
	blower = P_SpawnMobjFromMobj(sponge.mo, 0, 0, -48*FRACUNIT * P_MobjFlip(sponge.mo), MT_OVERLAY)
	blower.target = sponge.mo
	blower.tracer = sponge.mo
	blower.state = S_SUPERSPONGE_BLOWER
	
	// Set X and Y scale
	blower.spritexscale = sponge.mo.spritexscale/2
	blower.spriteyscale = sponge.mo.spriteyscale/2
	
	// Set X and Y offsets
	blower.spritexoffset = sponge.mo.spritexoffset
	blower.spriteyoffset = sponge.mo.spriteyoffset
	
	if not (blower and blower.valid) then
		return
	end
	
	// Set blower mobj
	sponge.ssvars.blower.mo = blower	
end

// SB_SpawnHelmetOverlay
local function SB_SpawnHelmetOverlay(sponge)

	local cvar
	local helmet
	
	if not P_IsSuperSponge(sponge.mo.skin) then
		return
	end

	helmet = P_SpawnMobj(sponge.mo.x, sponge.mo.y, sponge.mo.z, MT_OVERLAY)
	helmet.tracer = sponge.mo
	helmet.target = sponge.mo
	helmet.state = S_SUPERSPONGE_HELMET
	
	if not (helmet and helmet.valid) then
		return
	end
	
	sponge.ssvars.helmet = helmet // Set mobj
end

// SB_SpawnPantsOverlay
local function SB_SpawnPantsOverlay(sponge)

	local cvar
	local pants
	
	if not P_IsSuperSponge(sponge.mo.skin) then
		return
	end

	// Spawn the pants overlay
	pants = P_SpawnMobjFromMobj(sponge.mo, 0, 0, 0, MT_OVERLAY)
	pants.tracer = sponge.mo
	pants.target = sponge.mo
	pants.state = S_SUPERSPONGE_PANTS

	// Shrink the player's pants to match hires scale.
	pants.spritexscale = sponge.mo.spritexscale/4
	pants.spriteyscale = sponge.mo.spriteyscale/4
	
	if not (pants and pants.valid) then
		return
	end
	
	sponge.ssvars.pants.mo = pants // Set mobj
end

// P_SpawnAimedMissile
// Spawns a set amount of missiles aimed at a given target.
local function P_SpawnAimedMissile(mobj, dest, type, amount)

	local player
	local ammo
	local tripleshot
	local rocket

	if not (mobj and mobj.valid and dest and dest.valid) then
		return
	end
	
	player = mobj and mobj.player
	ammo = player and player.ssvars and player.ssvars.ammo["jellyfish"] or 0
	tripleshot = false

	mobj.angle = R_PointToAngle2(mobj.x, mobj.y, dest.x, dest.y)
	
	if (player) then

		// The player is about to fire a triple shot.
		if (amount >= 3) then
			tripleshot = true
		end
	
		player.drawangle = mobj.angle
	end
	
	if (tripleshot)
	
		for i = 1, 3 do
		
			local ang
			local rocket
			
			rocket = P_SpawnMissile(mobj, dest, type)
	  
			if (i == 3) then
				ang = mobj.angle + FixedAngle(8*FRACUNIT) // right
			elseif (i == 2) then
				ang = mobj.angle + FixedAngle(-8*FRACUNIT) // left
			else
				ang = mobj.angle
			end
			
			P_InstaThrust(rocket, ang, rocket.info.speed)
			
		end
	else
		rocket = P_SpawnMissile(mobj, dest, type) 
	end
	
	if not (rocket and rocket.type == MT_SUPERSPONGE_BUBBLEMISSILE and not tripleshot) then 
		return // Only halve the bubble missile's scale and set flags2
	end
	
	rocket.scale = 7*FRACUNIT/10 
	rocket.flags2 = $|MF2_SUPERFIRE
end

// SB_GetShieldFromPowerup
// Hooray, today's opposite day!
rawset(_G, "SB_GetShieldFromPowerup", function(player)
	
	local tbl = supersponge_powerup_info	
	local newshield = 0
	local lastgear = 0
	
	for i = 1, #tbl, 1 do
	
		local shield = tbl[i] and tbl[i].shield or nil
		local priority = tbl[i] and tbl[i].priority or 0
	
	
		// The Armageddon Shield will always take high priority over all other shields.
		if (player.ssvars.powerups[SS_POWERUP_PIE] > 0) then 
		
			lastgear = SS_POWERUP_PIE 
			newshield = SH_ARMAGEDDON 
			
			break 
		end
	
		if not (tbl[i].type == SS_TYPE_GEAR and shield and priority > -1) then
			continue // The gear must have a corresponding shield and cannot be combined.
		end

		if not (player.ssvars.powerups[i]) then 
			continue // The player does not have the corresponding gear.
		end
		
		lastgear = i
		newshield = shield // Set the "new" shield to take the place of our old one.
	end

	if (lastgear) then	
		P_RemoveSSPowerup(player, lastgear, false) // Remove the gear from the player's powerup array.
	end
	
	// If we could not find a shield to replace our previous shields with, use our existing set.
	if not (newshield) then 
	
		if (player.ssvars.realshield) then
		
			// print("Your previous shields were restored.")
	
			P_SwitchShield(player, 0)
			P_SwitchShield(player, player.ssvars.realshield)
			
			player.ssvars.realshield = 0
		end
		
		return false
	end
		
	P_SwitchShield(player, 0)
	P_SwitchShield(player, newshield)
	
	return true
end)

// SB_GetPowerupFromShield
// Retrieves a powerup from the corresponding shield
rawset(_G, "SB_GetPowerupFromShield", function(player, dosfx)
	
	local tbl = supersponge_powerup_info
	local oldgear = P_GetCurrentSSGear(player)
	local oldweapon = P_GetCurrentSSWeapon(player)
	
	// No shield. No service.
	if not (player.powers[pw_shield]) then
		return
	end
	
	// If powerups are not enabled, just give the shield power as usual.
	if not (P_IsSuperSponge(skins[player.skin].name) and player.ssvars and cv_powerups.value > 0) then
		return
	end

	for i = 1, #tbl, 1 do
	
		local shield = tbl[i] and tbl[i].shield
		local oldshield = player.powers[pw_shield]
		local stack = (player.powers[pw_shield] & SH_STACK)
		local hp = (player.powers[pw_shield] & SH_FORCEHP)
		
		if not (tbl[i] and tbl[i].shield) then continue end // this entry lacks a shield
		
		if (shield == SH_FORCE and player.powers[pw_shield] & SH_FORCE) then
			shield = $|hp
		end
		
		// The player does not have the corresponding shield.
		if not (player.powers[pw_shield] == shield)
		and not (player.powers[pw_shield] == shield|stack) then
			continue 
		end
		
		player.powers[pw_shield] = $ & ~shield
		
		// Add the shield to the old shield array.
		if not (player.ssvars.realshield & shield)
		or not (player.ssvars.realshield & shield|stack) then
			player.ssvars.realshield = shield|stack
		end
		
		// Never replace the player's space suit with the helmet!
		if (i == SS_POWERUP_HELMET and player.ssvars.powerups[SS_POWERUP_SUIT]) then
			break
		end
		
		// If we cannot equip the powerup, do not use it.
		if not P_PlayerCanGrabPowerup(player, i, true) then
			continue
		end
		
		// Remove your current equipment.
		if (tbl[i].type == SS_TYPE_GEAR and oldgear) then
			P_RemoveSSPowerup(player, oldgear, false)
		elseif (tbl[i].type == SS_TYPE_WEAPON and oldweapon and tbl[i].priority > -1) then
			P_RemoveSSPowerup(player, oldweapon, false)
		end
				
		// Give the corresponding powerup.
		if P_IsSuperSponge(player.mo.skin) then
			P_GiveSSPowerup(player, i, dosfx)
		else
			P_GiveSSPowerup(player, i, false)
		end
		
		break
	end
	
	// To stop foxBotAI from infinitely spawning shields.
	if (player.bot > 0 and player.ai != nil) then
		player.powers[pw_shield] = 0x0096|$
	else
		player.powers[pw_shield] = $ & ~0x0096
	end
	
	return true
end)
addHook("ShieldSpawn", SB_GetPowerupFromShield)

// SB_GetActiveShield
// Retrieves the active "shield" for player.
local function SB_GetActiveShield(player)

	local shield = 0

	if P_IsPowerupActive(player, SS_POWERUP_PIE) then
		shield = SS_POWERUP_PIE
	elseif P_IsPowerupActive(player, SS_POWERUP_SUIT) then
		shield = SS_POWERUP_SUIT
	elseif P_IsPowerupActive(player, SS_POWERUP_HELMET) then
		shield = SS_POWERUP_HELMET
	elseif P_IsPowerupActive(player, SS_POWERUP_GLASSES) then
		shield = SS_POWERUP_GLASSES
	elseif P_IsPowerupActive(player, SS_POWERUP_BOOTS)
		shield = SS_POWERUP_BOOTS
	end
	
	return shield
end

// P_StopRagingWhirlpool
local function P_StopRagingWhirlpool(sponge)
	sponge.ssvars.whirlpooling = false
	sponge.ssvars.whirlpooltimer = 0
end

// P_StopButtBounce
rawset(_G, "P_StopButtBounce", function(sponge, sound, bounce)

	if (bounce) then
		sponge.mo.state = S_PLAY_JUMP
		sponge.ssvars.jmpcount = 1
	end

	if (sound) then
		S_StartSound(sponge.mo, sfx_btbnce, sponge)
	end
	
	sponge.pflags = $ & ~PF_JUMPED
	sponge.ssvars.buttbounce = false
	sponge.powers[pw_strong] = $ & ~STR_SPRING
end)

// P_ResetWeaponSprites
local function P_ResetWeaponSprites(player)

	if (player.ssvars.wp_sprites == nil) then
		player.ssvars.wp_sprites = {}
	end

	for k,v in pairs(supersponge_weapon_sprites) do
		player.ssvars.wp_sprites[k] = v
	end
	
	player.ssvars.wp_tics = 0
end

// P_ResetSpongeVars
// Resets Spongebob's variables back to default
local function P_ResetSpongeVars(sponge, reset_ammo)

	if P_IsButtBouncing(sponge) then
		P_StopButtBounce(sponge, false)
	end

	sponge.ssvars.jmpcount = 0 // Jump Count
	sponge.ssvars.jmpbtntimer = 0 // Jump Button Timer
	sponge.ssvars.spinbtntimer = 0 // Spin Button Timer
	sponge.ssvars.holdingjump = false // Hold Jump Check
	sponge.ssvars.canbounce = false // Bounce Check
	sponge.ssvars.springtimer = 0 // Spring Animation Timer
	sponge.ssvars.chopping = false // Chop Flag
	sponge.ssvars.airchopping = false // Air Chop Flag
	sponge.ssvars.fishing = false // Net Flag
	sponge.ssvars.whirlpooling = false // Whirl Flag
	sponge.ssvars.meleetimer = 0 // Chopping Timer
	sponge.ssvars.shoottimer = 0 // Shooting Timer		
	sponge.ssvars.whirlpooltimer = 0 // Whirl Timer
	sponge.ssvars.lockon = nil // Lock-On Target
	sponge.ssvars.rayframe = 0 // Shrink-Ray Frame
	sponge.ssvars.raytics = 2 // Shrink-Ray Tics
	sponge.ssvars.zapping = false // Shrink-Ray Flag
	sponge.ssvars.bframe = 0 // Walking W/ Blower Frame
	sponge.ssvars.tripleshot = false // Triple-Shot Flag
	sponge.ssvars.hitbox = nil // Hitbox Object
	
	P_ResetWeaponSprites(sponge)
	
	// Reset Jellyfish Net variables
	sponge.ssvars.net.status = 0
	sponge.ssvars.net.obstructor = nil
	sponge.ssvars.net.mode = 0
	
	// Reset Reef Blower variables
	sponge.ssvars.blower.status = 0
	sponge.ssvars.blower.obstructor = nil
	sponge.ssvars.blower.mode = 0
	sponge.ssvars.blower.hitbox = nil
	sponge.ssvars.blower.cooldown = 0
	sponge.ssvars.blower.mo = nil
	sponge.ssvars.blower.noise = 0

	sponge.ssvars.clams = {} // Clam Objects
	
	// Reset player stats
	sponge.jumpfactor = skins[sponge.skin].jumpfactor
	sponge.normalspeed = skins[sponge.skin].normalspeed
	sponge.runspeed = skins[sponge.skin].runspeed
	sponge.acceleration = skins[sponge.skin].acceleration
	
	// Reset hydration flag
	sponge.ssvars.hydrated = false
	sponge.ssvars.hydratedtics = 0
	
	// Reset Spongebob flag
	sponge.ssvars.is_spongebob = false
	
	// Don't keep powerups if we're in a non-cooperative gametype or the ability for Spongebob to keep his powerups is disabled.
	if (reset_ammo or cv_keeppowerups.value <= 0) then P_RemoveSSPowerups(sponge, false) end
end

// InitSpongeVars
// Initalizes Spongebob's variables upon spawning
local function InitSpongeVars(sponge)

	local tbl = supersponge_powerup_info
	
	// All variables are already initialized.
	if (sponge.ssvars != nil and type(sponge.ssvars) == "table") then P_ResetSpongeVars(sponge, false) return end 
	
	sponge.ssvars = {}
	sponge.ssvars.buttbounce = false // Butt Bounce Flag
	sponge.ssvars.jmpcount = 0 // Jump Count
	sponge.ssvars.jmpbtntimer = 0 // Jump Button Timer
	sponge.ssvars.spinbtntimer = 0 // Spin Button Timer
	sponge.ssvars.holdingjump = false // Hold Jump Check
	sponge.ssvars.canbounce = false // Bounce Check
	sponge.ssvars.springtimer = 0 // Spring Animation Timer
	sponge.ssvars.chopping = false // Chop Flag
	sponge.ssvars.airchopping = false // Air Chop Flag
	sponge.ssvars.fishing = false // Net Flag
	sponge.ssvars.whirlpooling = false // Whirl Flag
	sponge.ssvars.meleetimer = 0 // Chopping Timer
	sponge.ssvars.shoottimer = 0 // Shooting Timer
	sponge.ssvars.whirlpooltimer = 0 // Whirl Timer
	sponge.ssvars.powerups = {} // Powerup Table
	
	for i=1, #supersponge_powerup_info do
		if (tbl[i] == nil) then 
			continue // entry does not exist
		end
		if not (tbl[i].type and (tbl[i].type == SS_TYPE_WEAPON or tbl[i].type == SS_TYPE_GEAR)) then 
			continue // add only weapons or gear
		end
		sponge.ssvars.powerups[i] = 0
	end
	
	sponge.ssvars.lockon = nil // Lock-On Target
	sponge.ssvars.rayframe = 0 // Shrink Ray Frame
	sponge.ssvars.raytics = 2 // Shrink Ray Tics
	sponge.ssvars.zapping = false
	sponge.ssvars.bframe = 0 // Walking W/ Blower Frame
	sponge.ssvars.tripleshot = false // Triple Shot Flag
	
	P_ResetWeaponSprites(sponge)
	
	sponge.ssvars.net = {
		status = 0,
		things = {}, // Captured things
		obstructor = nil,
		mode = 0, // current mode
	}
	sponge.ssvars.blower = {
		status = 0,
		things = {}, // Captured things
		hitbox = nil,
		active = false,
		obstructor = nil,
		cooldown = 0,
		mo = nil,
		noise = 0
	} 
	
	sponge.ssvars.menu = {
		layout = nil,
		active = false,
		cursor_pos = 0,
		delay = 0
	}
	
	sponge.ssvars.ammo = {
		["jellyfish"] = 0, // Jellyfish Launcher Ammo
		["bubbles"] = 0, // Bubble Wand Ammo
		["things"] = {}
	}
	
	sponge.ssvars.clams = {} // Clam Objects
	
	// Reset player stats
	sponge.jumpfactor = skins[sponge.skin].jumpfactor
	sponge.normalspeed = skins[sponge.skin].normalspeed
	sponge.runspeed = skins[sponge.skin].runspeed
	sponge.acceleration = skins[sponge.skin].acceleration
	
	// Reset hydration flag
	sponge.ssvars.hydrated = false
	sponge.ssvars.hydratedtics = 0
	
	sponge.ssvars.pants = {mo = nil, color = SKINCOLOR_NONE} // Pants Overlay
	
	// Update the pants variable
	if (sponge.bot <= 0) then
		if (sponge == secondarydisplayplayer) then
			COM_BufInsertText(sponge, "ss_pantscolor2" + " " + '"' + ss_lastpantscolor2 + '"' + " " + "+x")	
		elseif (sponge == consoleplayer) then
			COM_BufInsertText(sponge, "ss_pantscolor" + " " + '"' + ss_lastpantscolor + '"' + " " + "+x")
		end
	else
		if P_IsSuperSponge(sponge.mo.skin) then
		
			local color = 114
			local skincolor = SKINCOLOR_NONE
			
			// get random pants color for bots
			while (color != SKINCOLOR_NONE and skincolors[color] and not skincolors[color].valid and not skincolors[color].accessible) do
			
				local name = sponge.name:lower()
				local newcolor = P_RandomRange(0, #skincolors - 1)
				
				// If the bot's name contains a certain character's name, change to match.
				if (string.find(name, "spongebob")) then
					newcolor = SKINCOLOR_NONE
					skincolor = SKINCOLOR_YELLOW
				elseif (string.find(name, "patrick")) then
					newcolor = SKINCOLOR_CHARTREUSE
					skincolor = SKINCOLOR_PINK
				elseif (string.find(name, "squidward")) then
					newcolor = SKINCOLOR_BROWN
					skincolor = SKINCOLOR_TEAL
				elseif (string.find(name, "krabs")) then
					newcolor = SKINCOLOR_ARCTIC
					skincolor = SKINCOLOR_RED
				elseif (string.find(name, "sandy")) then
					newcolor = SKINCOLOR_SILVER
					skincolor = SKINCOLOR_LATTE
				elseif (string.find(name, "gary")) then
					newcolor = SKINCOLOR_PINK
					skincolor = SKINCOLOR_AQUA
				elseif (string.find(name, "plankton")) then
					newcolor = SKINCOLOR_SHAMROCK
					skincolor = SKINCOLOR_GREEN
				end
				
				color = newcolor
			end
			
			// Change the bot's skincolor.
			if (skincolor) then
				sponge.mo.color = skincolor
				sponge.skincolor = skincolor
			end
			
			sponge.ssvars.pants.color = color
		end
	end
	
	sponge.ssvars.helmet = nil // Space Helmet Overlay
	sponge.ssvars.weapon = nil // Weapon Mobj
	sponge.ssvars.balloon = nil // Balloon Mobj
	sponge.ssvars.is_spongebob = false // Spongebob Flag
	sponge.ssvars.realshield = 0 // Old Shields
	sponge.ssvars.likeskrabbypatties = false // Krabby Patty Flag
	sponge.ssvars.pressedfire = false // BT_ATTACK Flag
	sponge.ssvars.camangle = 0 // Camera Angle
end
addHook("PlayerSpawn", InitSpongeVars)

// A fix for the Egg Colosseum boss - if powerups are turned on that is.
addHook("MapLoad", function(gamemap)

	local is_bonustype_boss = mapheaderinfo[gamemap].bonustype == 1
	local is_egg_colosseum_bossfight = false
	
	if not (is_bonustype_boss and cv_powerups.value) then return end // The map is a not a boss map or powerups are turned off.
	
	for mo in mobjs.iterate() do if (mo.type == MT_EGGMOBILE4) is_egg_colosseum_bossfight = true break end end // In the map, check if we're fighting the Egg Colosseum.
	
	if not (is_egg_colosseum_bossfight) then 
		return // We have a chance to win the fight then.
	end
	
	// Look for players who are Spongebob before spawning pickups.
	for p in players.iterate() do
	
		if not P_IsSuperSponge(skins[p.skin].name) then 
			continue
		end
		
		P_SpawnSSPickup(p.mo.x, p.mo.y, p.mo.z, SS_POWERUP_LAUNCHER, 0) // spawn launcher pickup near player.
	end
end)

// Only reset Spongebob's variables when changing maps.
addHook("MapChange", function(gamemap)
	for p in players.iterate() do 
	
		if not (p and p.valid and p.ssvars) then	
			continue 
		end
		
		P_ResetSpongeVars(p, (gametype != GT_COOP))
	end
end)

// Bot thinker for Spongebob bots
addHook("BotTiccmd", function(patrick, cmd)

	// Initalize Spongebob variables for bot.
	if (patrick.ssvars == nil) then
		InitSpongeVars(patrick)
	end
	
	// TODO: maybe add some more stuff here in the future
	
	return
end)


//////////////////////////////////////////
//          Main Functions             //
////////////////////////////////////////

local supersponge_victorytaunts = {
	sfx_sbvic1,
	sfx_sbvic2,
	sfx_sbvic3,
	sfx_sbvic4,
	sfx_sbvic5,
	sfx_sbvic6,
	sfx_sbvic7,
	sfx_sbvic8,
	sfx_sbvic9,
	sfx_sbvica
}


// 
// SB_DoWeaponAction
//
// Checks if the respective weapon has an action and executes it before
//
local function SB_DoWeaponAction(player)

	local tbl
	local weapon
	local priority
	local action
	local func
	
	tbl = supersponge_powerup_info
	weapon = P_GetCurrentSSWeapon(player)
	priority = tbl[weapon] and tbl[weapon].priority
	
	// The pie always take higher priority over other weapons
	if (player.ssvars.powerups[SS_POWERUP_PIE] > 0) then
		action = "SB_PieAction"
	elseif (player.powers[pw_super] > 0 and priority > -2) then
		action = "SB_SuperAction"
	else
		action = tbl[weapon].action
	end
	
	func = _G[action]
	
	if (func == nil or func and type(func) != "function") then
		return false // the functio does not exist
	end
	
	local res = func(player)
	
	if (res == nil) then
		res = true // set to true by default
	end
		
	return res
end

// 
// SB_CheckWeaponAction
//
// Checks if the player can perform an action using a weapon.
//
local function SB_CheckWeaponAction(player)

	local override = false

	if not (player.ssvars and cv_powerups.value) then 
		return false // Spongebob's powerups are disabled!
	end
	
	if (P_GetSSPowerupCount(player, SS_TYPE_WEAPON) == 0 and player.powers[pw_super] <= 0) then
		return false // We have no weapons or the player is not super.
	end
	
	if SB_DoWeaponAction(player) then
		override = true
	end
	
	return override
end
	
//
// SB_IsTheDestroyerOfEvil
//
// Checks to see whether player is the "destroyer" of evil by checking score, times hit, or the opposing target's name.
//
local function SB_IsTheDestroyerOfEvil(player, target)

	local destroyer = false
	local name = target.player and target.player.valid and target.player.name:lower() or "-"
	local is_target_doodlebob = target.skin == "doodlebob" or name:find("doodlebob") or name:find("doodle bob")

	if not (P_RandomByte()&2) then return false end // Still up to random chance.
	
	if (player.score >= 5000 or player.timeshit <= 0 or is_target_doodlebob) then
		destroyer = true // Play the taunt, if the player has at least 5,000 points, never got hit, or the target's name has "Doodle Bob" in it.
	end

	return destroyer
end

//
// VictoryScreech
//
// Executes a "victory screech" after defeating a boss
//
local function VictoryScreech(target, inflictor, sponge)

	local player
	local taunts
	local screech
	local is_destroyer

	// where's spongebob?
	if not (sponge and sponge.valid and sponge.player and P_IsSuperSponge(sponge.skin)) then
		return
	end
	
	// taunts are disabled
	if not (cv_taunts.value and cv_victorytaunts.value) then
		return
	end
		
	// only yell your taunt at players / bosses that you have defeated
	if not (target and target.player or target and (target.flags & MF_BOSS)) then
		return
	end
	
	player = sponge.player
	taunts = supersponge_victorytaunts
	screech = taunts[P_RandomRange(1, #taunts)]
	is_destroyer = SB_IsTheDestroyerOfEvil(sponge.player, target)
	
	// If the 6th taunt was chosen, check if we met the criteria to actually use it.
	if (screech == sfx_sbvic6 and not is_destroyer) then
		// re-randomize taunt.
		while (screech == sfx_sbvic6) do
			screech = taunts[P_RandomRange(1, #taunts)] 
		end
	end

	S_StartSound(sponge.mo, screech) // DO YOUR VICTORY SCREECH!
end
addHook("MobjDeath", VictoryScreech)

//
// R_DrawShrinkRay
//
// Code based on sprkizard's line pathing function
//
local function R_DrawShrinkRay(player, mo, mo2)

	local laser
	local distance
	local points
	local frame
	
	distance = P_AproxDistance(P_AproxDistance(mo2.x - mo.x, mo2.y - mo.y), mo2.z - mo.z)
	points = distance/(32<<FRACBITS)
	
	for i = 1, points, 1 do
		
		laser = P_SpawnMobj(mo.x+(mo2.x-mo.x)/points/2*(2*i-1),
                            mo.y+(mo2.y-mo.y)/points/2*(2*i-1),
                            mo.z+(mo2.z-mo.z)/points/1*(1*i-1), MT_SUPERSPONGE_SHRINKRAY)
							
		laser.target = player.mo
			
		// Set scale
		laser.scale = FRACUNIT/2
		
		// Set frame
		laser.frame = FF_PAPERSPRITE|player.ssvars.rayframe
			
		// Set angle
		laser.angle = R_PointToAngle2(mo2.x, mo2.y, mo.x, mo.y)
		
		// Set color
		laser.color = SKINCOLOR_MASTER
		laser.colorized = true
		
		// Set rollangle
		laser.rollangle = R_PointToAngle2(0, mo2.z, distance, mo.z)
	end
end

//
// R_DrawBalloonString
//
// Code based on sprkizard's line pathing function
//
local function R_DrawBalloonString(mo, mo2)
	
	local x1, x2, y1, y2
	local z1, z2
	local segment
	local distance
	local points
	local frame
	local angle
	
	distance = P_AproxDistance(P_AproxDistance(mo2.x - mo.x, mo2.y - mo.y), mo2.z - mo.z)
	
	if (mo2.player) then
		angle = mo2.player.drawangle
	else
		angle = mo2.angle
	end
	
	x1 = mo.x
	y1 = mo.y
	
	// For the "holder," center the string in the middle of mobj
	x2 = mo2.x + P_ReturnThrustX(mo2, angle, -4*FRACUNIT)
	y2 = mo2.y + P_ReturnThrustY(mo2, angle, -4*FRACUNIT)
	
	// Adjust the string between the head of the holder and the "pivot" of the balloon
	if P_MobjFlip(mo2) == -1 then
		z1 = mo.z + mo2.height - 12*FRACUNIT
		z2 = mo2.z + 2*FRACUNIT
	else
		z1 = mo.z - 2*FRACUNIT
		z2 = mo2.z + mo2.height - 8*FRACUNIT
	end
	
	// Update line coordinates
	if (mo.segs != nil and mo.segs[1] and mo.segs[1].valid) then
	
		for i = 1, STRING_LENGTH, 1 do
			
			local nx = x1+(x2-x1)/STRING_LENGTH/2*(2*i-1)
			local ny = y1+(y2-y1)/STRING_LENGTH/2*(2*i-1)
			local nz = z1+(z2-z1)/STRING_LENGTH/1*(1*i-1)
		
			P_MoveOrigin(mo.segs[i], nx, ny, nz)
		end
		
		return
	end
	
	mo.segs = {}
	
	// Spawn segments which will make up the "string"
	for i = 1, STRING_LENGTH, 1 do
		mo.segs[i] = P_SpawnMobj(x1+(x2-x1)/STRING_LENGTH/2*(2*i-1),
								 y1+(y2-y1)/STRING_LENGTH/2*(2*i-1),
								 z1+(z2-z1)/STRING_LENGTH/1*(1*i-1), MT_THOK)
		mo.segs[i].target = mo
		mo.segs[i].state = S_SUPERSPONGE_STRING
		mo.segs[i].flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOBLOCKMAP
		mo.segs[i].angle = R_PointToAngle2(mo2.x, mo2.y, mo.x, mo.y)
		mo.segs[i].scale = FRACUNIT/16
		mo.segs[i].color = SKINCOLOR_WHITE
		mo.segs[i].rollangle = R_PointToAngle2(0, mo2.z, distance, mo.z)
	end
end

// 
// P_ActivateRagingWhirlpool
//
// Activates the "Raging Whirlpool"
//
local function P_ActivateRagingWhirlpool(sponge)

	local bubble
	local height
	
	height = -32*FRACUNIT
	
	// Clear previous whirlpool bubbles before spawning new ones
	for bubble in mobjs.iterate() do 
		if not (bubble and bubble.valid and bubble.type == MT_SUPERSPONGE_VORTEXBUBBLE) then 
			continue 
		end
		// Remove the bubble.
		if (bubble.target == sponge.mo) then P_RemoveMobj(bubble) end
	end

	// Spawn whirlpool particles
	for i=1, 16 do
	
		bubble = P_SpawnMobjFromMobj(sponge.mo, 0, 0, 0, MT_SUPERSPONGE_VORTEXBUBBLE)	
		
		// Set column height
		bubble.extravalue1 = height
		
		// Set angle and target
		bubble.angle = ANGLE_45 * i
		bubble.target = sponge.mo
		
		// Set color
		bubble.color = SKINCOLOR_BLUE
		bubble.colorized = true
		bubble.flags2 = $|MF2_SUPERFIRE
		
		height = $ + 8*FRACUNIT
	end
	
	sponge.ssvars.whirlpooling = true
end

//
// P_SpongeLockOn
//
// Spongebob specific version of P_LockOn
//
local function P_SpongeLockOn(sponge)

	local lockon = P_LookForEnemies(sponge, false, true)
	
	sponge.ssvars.lockon = nil
	
	if not (lockon and lockon.valid) then return end // no targets were found
		
	sponge.ssvars.lockon = lockon
	
	// Do not spawn the LOCK-ON if Spongebob's current ability is CA2_GUNSLINGER!
	if (sponge.charability2 == CA2_GUNSLINGER) then 
		return 
	end
	
	P_SpawnLockOn(sponge, lockon, S_LOCKON1)
end


//
// P_LaunchExplodingPie
//
// Handles the launching of the exploding pie
//
local function P_LaunchExplodingPie(sponge)
	
	local missile = P_SPMAngle(sponge.mo, MT_SUPERSPONGE_PIE, sponge.drawangle, 0, MF2_EXPLOSION|MF2_SUPERFIRE)
	
	sponge.ssvars.powerups[SS_POWERUP_PIE] = 0
	sponge.ssvars.realshield = 0
	
	// Our pie exploded prematurely!
	if not (missile and missile.valid) then
		return
	end
	
	missile.scale = $ * 1/2
	
	S_StartSound(missile, sfx_sbpie) // Oops!
	
	// To simulate lobbing an object, throw the pie upwards by 8 FRACUNITS.
	if (P_MobjFlip(missile) == -1) then
		P_SetObjectMomZ(missile, -8*FRACUNIT, true)
	else
		P_SetObjectMomZ(missile, 8*FRACUNIT, true)
	end
end

//
// SpongeJumpSpecial
//
// Jump ability handler for Spongebob
//
local function SpongeJumpSpecial(sponge)
	
	local in_jumpstate
	
	// Spongebob only.
	if not P_IsSuperSponge(sponge.mo.skin) then
		return
	end	
	
	// Never check in SRB2infinity.
	if PSOIsEnabled() then
		return true
	end
	
	// Can't use custom ability...
	if (sponge.charability != CA_NONE) then
		return
	end
	
	//The player is currently being carried by something.
	if (sponge.powers[pw_carry] > 0) then
		return
	end
	
	// Holding jump...
	if (sponge.pflags & PF_JUMPDOWN) then
		return
	end
	
	in_jumpstate = P_IsInJumpState(sponge) or sponge.mo.state == S_PLAY_FALL
	
	// The blower is active!
	if (P_IsPowerupActive(sponge, SS_POWERUP_BLOWER) and sponge.powers[pw_super] <= 0) then
		return
	end
	
	// The player is already butt-bouncing or we are currently not jumping or falling yet.
	if (P_IsButtBouncing(sponge) or not in_jumpstate) then
		return
	end
	
	// If we haven't pressed the jump button more than once already or we're not in the falling state, do not butt-bounce.
	if not (sponge.ssvars.jmpcount >= 2 or sponge.mo.state == S_PLAY_FALL or P_IsWhirlpooling(sponge)) then
		return
	end
	
	sponge.ssvars.buttbounce = true
	sponge.ssvars.jmpcount = 0
	sponge.mo.state = S_PLAY_SSBNCE
	
	P_SetObjectMomZ(sponge.mo, -16*FRACUNIT, false)
end
addHook("JumpSpecial", SpongeJumpSpecial)

//
// SpongeSpinSpecial
//
// Spin special handler for Spongebob
//
local function SpongeSpinSpecial(sponge)

	local sound
	
	// Spongebob only.
	if not P_IsSuperSponge(sponge.mo.skin) then
		return false
	end
	
	// Never check in SRB2infinity.
	if PSOIsEnabled() then
		return true
	end
	
	// Check if the player has any active powerups before using the karate gloves.
	if SB_CheckWeaponAction(sponge) then
		return true
	end
	
	// Uh oh! I forgot my karate gloves!
	if (sponge.charability2 != CA2_MELEE)
		return false
	end
	
	// Let's make sure our player is ready before doing any "kara-tay!"
	if not P_CanSpongeChop(sponge)
		return true
	end
	
	// Set the melee timer before performing the karate chop
	sponge.ssvars.meleetimer = SS_KARATE_COOLDOWN
	
	// Thrust the player forwards
	if P_IsObjectOnGround(sponge.mo) or not P_IsObjectOnGround(sponge.mo) and not sponge.ssvars.airchopping
		P_Thrust(sponge.mo, sponge.drawangle, 8*FRACUNIT)
	end
	
	// Set player's state to S_PLAY_SSCHOP
	sponge.mo.state = S_PLAY_SSCHOP
	
	// Activate chopping power!
	sponge.powers[pw_strong] = STR_PUNCH|STR_HEAVY|STR_WALL|STR_SPRING|STR_SPIKE

	// Upon performing the action, choose a random sound to play between chops.
	if (P_RandomByte()&1) then
		sound = sfx_krch1
	else
		sound = sfx_krch2
	end
	
	// If we aren't touching any walls, then we are moving through the air.
	if not P_IsObjectOnGround(sponge.mo) and sponge.powers[pw_pushing] <= 0  then
		sponge.ssvars.airchopping = true
	end
	
	sponge.ssvars.chopping = true
	
	S_StartSound(actor, sound)

	return true
end
addHook("SpinSpecial", SpongeSpinSpecial)

//
// SpongeBubbleHandler
// 
// Stop Spongebob from grabbing air bubbles.
//
local function SpongeBubbleHandler(special, toucher)
	if P_IsSuperSponge(toucher.skin) return true end // "I DON'T NEED IT!!!!"
end
addHook("TouchSpecial", SpongeBubbleHandler, MT_EXTRALARGEBUBBLE)

//
// GiveAmmoFromPickup
//
// Retrieves ammo from dropped weapon pickups
//
local function GiveAmmoFromPickup(player, special)

	local pickup = special.powerup
	local ammo = supersponge_powerup_info[pickup].ammo or 0
	local ammotype = supersponge_powerup_info[pickup].ammotype != nil and supersponge_powerup_info[pickup].ammotype or "none"
	local maxammo = supersponge_powerup_info[pickup].maxammo or 0
	
	if not (pickup) then
		return // This pickup has no powerups associated with it.
	end
	
	if not (ammo) then 
		return // This powerup has no ammo.
	end
	
	if (ammotype == nil or not ammo or ammotype and ammotype:lower() == "none") then 
		return // No defined ammotype or there is no ammo to be given.
	end
	
	if (ammotype == "things" and special.things == nil) then
		return // No ammo.
	end
	
	// Handle each ammo type.
	if (ammotype == "things") then
	
		// Initalize array.
		if not (player.ssvars.ammo["things"]) then
			player.ssvars.ammo["things"] = {}
		end
		// Initalize subarray.
		if not (player.ssvars.ammo["things"][pickup]) then
			player.ssvars.ammo["things"][pickup] = {}
		end
	
		// If the pickup has things previously stored inside it, add it to our list.
		for i = 1, #(special.things), 1 do
			player.ssvars.ammo["things"][pickup][i] = special.things[i]
		end
		
		return
	end
	
	if (special.ammo != nil) then
		player.ssvars.ammo[ammotype] = $ + special.ammo
	else
		player.ssvars.ammo[ammotype] = $ + ammo
	end
	
	// Don't try to go over the limit.
	if (player.ssvars.ammo[ammotype] > maxammo) then
		player.ssvars.ammo[ammotype] = maxammo
	end
end

//
// SpongePickupHandler
//
// Handles Spongebob's interaction with pickups
//
local function SpongePickupHandler(special, toucher)

	local sponge = toucher.player
	local powerups = sponge.ssvars.powerups
	local weapon = P_GetCurrentSSWeapon(sponge)
	local pickup = special.powerup
	local tbl = supersponge_powerup_info
	local sound = nil

	// Never pick up the powerup, unless you are Spongebob.
	if not (P_IsSuperSponge(toucher.skin) and cv_powerups.value) then
		return true
	end
	
	// If it is non-existent, do not pick it up.
	if (pickup == nil) then
		return true
	end
	
	// The player must be in a ready state.
	if P_IsMovementLocked(sponge) then
		return true
	end
	
	// Just tossed something.
	if (sponge.tossdelay) then
		return true
	end
	
	// The player is currently performing actions
	if P_IsButtBouncing(sponge)
	or P_IsChopping(sponge)
	or P_IsReefBlowing(sponge)
	or P_IsJellyfishing(sponge) 
	or P_IsShooting(sponge) 
	or P_IsWhirlpooling(sponge) then
		return true
	end
		
	// Check for any "active" temporary powerups
	if not P_PlayerCanGrabPowerup(sponge, pickup) then
		return true
	end
	
	// Upon picking the powerup, give it to the player.
	P_GiveSSPowerup(sponge, pickup, true)
	
	return false
end
addHook("TouchSpecial", SpongePickupHandler, MT_SUPERSPONGE_PICKUP)

//
// SpongePowerupHandler
//
// Handles powerup pickup
//
local function SpongePowerupHandler(special, toucher)

	local sponge = toucher.player
	local powerups = sponge.ssvars.powerups
	local tbl = supersponge_powerup_info
	local pickup = special.powerup
	local type = tbl[pickup].type or SS_TYPE_NONE
	local give = false
	local amount = nil

	// Try letting the player pick up the powerup while touching it.
	if not (P_IsObjectOnGround(special) and sponge.cmd.buttons & BT_TOSSFLAG) then return true end
	
	// Never pickup, unless you are Spongebob.
	if not (P_IsSuperSponge(toucher.skin) and cv_powerups.value) then return true end
	
	// The player must be in a ready state.
	if P_IsMovementLocked(sponge) then return true end
	
	// Just tossed something.
	if (sponge.tossdelay) then return true end
	
	// The player is currently performing actions
	if P_IsButtBouncing(sponge)
	or P_IsChopping(sponge)
	or P_IsReefBlowing(sponge)
	or P_IsJellyfishing(sponge) 
	or P_IsShooting(sponge) 
	or P_IsWhirlpooling(sponge) then
		return true
	end
		
	// Give the powerup, if not already picked up.
	if not (powerups[pickup]) then
		give = true
	end
	
	// If we're not giving it, then we must already have the powerup.
	if not (give) then
		// Try swapping it out first.
		if P_DoSSPowerupSwap(sponge, special) then
			return false
		else
			return true
		end
	end
		
	sponge.tossdelay = SS_TOSS_COOLDOWN
	
	// Check for any "active" temporary powerups
	if not P_PlayerCanGrabPowerup(sponge, pickup) then		
		return true
	end
	
	// Always give ammo from ammo pickups.
	if (tbl[pickup].type != SS_TYPE_AMMO and special.ammo != nil) then
		amount = 0
	end
	
	// If we gave the powerup, then give the player any previous ammo as well
	if P_GiveSSPowerup(sponge, pickup, false, amount) then
		GiveAmmoFromPickup(sponge, special)
	end

	return false
end
addHook("TouchSpecial", SpongePowerupHandler, MT_SUPERSPONGE_POWERUP)


///////////////////////////////////////////////
//			  Thinker Functions			    //
/////////////////////////////////////////////


//
// SpongeBossThinker
//
// Handles shrinking for bosses
//
local function SpongeBossThinker(mobj)
	if (mobj.supersponge_zapped == nil and mobj.supersponge_zaptics == nil) then
		return // we haven't been zapped yet!
	end
	// We haven't been zapped yet!
	if not (mobj.supersponge_zapped) then
		return
	end
	if (mobj.supersponge_zaptics > 0) then
		mobj.supersponge_zaptics = $ - 1 // deduct zap timer
	else
		if (mobj.destscale != mobj.supersponge_oldscale) then
			mobj.destscale = mobj.supersponge_oldscale // return to your old scale!
		end
		
		mobj.supersponge_zapped = false
	end
end
addHook("BossThinker", SpongeBossThinker)

//
// SpongeFakeMissileBounce
//
// A thinker for Spongebob's fake missiles to fix a problem with MF_GRENADEBOUNCE
//
local function SpongeFakeMissileBounce(mobj)
	if not (mobj and mobj.valid and mobj.health > 0) then return end
	if not (mobj.flags & MF_GRENADEBOUNCE) then return end
	// MF_GRENADEBOUNCE causes the missile to become stuck sometimes, so it is necessary to remove it.
	if (mobj.momx == 0 and mobj.momy == 0 and mobj.momz == 0) then
		P_KillMobj(mobj)
	end
end
addHook("MobjThinker", SpongeFakeMissileBounce, MT_SUPERSPONGE_FAKEMISSILE)

//
// SpongeSignpostSecondcolor
//
// Signpost Overlay Pants Handler
//
local function SpongeSignpostSecondcolor(mobj)

	local ov
	local target
	local player

	// Either player face hasn't been shown yet or the overlay is already displaying.
	if (mobj.state != S_SIGNPLAYER or mobj.ov2 and mobj.ov2.valid) then
		return
	end
	
	player = mobj.target.player
	
	// Our target is not Spongebob...
	if not (P_IsSuperSponge(mobj.target.skin) and player.ssvars.pants.color != SKINCOLOR_NONE) then
		return
	end
	
	mobj.ov2 = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_OVERLAY)
	mobj.ov2.target = mobj.tracer.tracer
	mobj.ov2.state = S_SUPERSPONGE_SIGNPOST_OVERLAY
	mobj.ov2.color = player.ssvars.pants.color
	mobj.ov2.spritexscale = mobj.tracer.tracer.spritexscale/4
	mobj.ov2.spriteyscale = mobj.tracer.tracer.spriteyscale/4
end
addHook("MobjThinker", SpongeSignpostSecondcolor, MT_SIGN)


///////////////////////////////////////////////
//			  Collision Functions			//
/////////////////////////////////////////////


// SpongeBubbleCollide
//
// Bubble collision handler for Spongebob's wand bubbles and air bubbles
//
local function SpongeBubbleCollide(mo, mo2)

	if not (mo and mo.valid and (mo.type == MT_SUPERSPONGE_BUBBLE) and mo2.type != MT_SUPERSPONGE_BUBBLE) then
		return false
	end
	
	// Check if we are standing on mobj.
	if (mo2.z + mo2.height/3 <= mo.z + mo.height)
		return false
	end
	
	// Reset butt-bounce counter if not already.
	if (mo2.player and mo2.player.valid and mo2.state != S_PLAY_JUMP) then
		mo2.player.ssvars.jmpcount = 0
	end
end
addHook("MobjCollide", SpongeBubbleCollide, MT_SUPERSPONGE_BUBBLE)

//
// SpongeMissileBlocked
//
// FOF collision handler for Spongebob's "fake" missiles
//
local function SpongeMissileBlocked(mobj, line)
	
	
	if not (line and line.valid) then
		return // the line 
	end
	
	if not (line.frontside and line.backside) then
		return // crumbling FOFs have at least two sides!
	end

	for i=0, 1 do
	
		local side
		local sector
		local fof
		
		side = sides[line.sidenum[i]] or nil
	
		if not (side and side.valid) then
			continue // invalid sidedef
		end
		
		sector = sides[line.sidenum[i]].sector
		
		if not (sector and sector.valid) then
			continue // doesn't exist
		end
	
		// Check for FOFs in the sector.
		for rover in sector.ffloors()
		
			if not (rover and rover.valid) then
				continue
			end
		
			if (mobj.z < rover.bottomheight)
			or (mobj.z > rover.topheight) then
				continue // not in between the FOF
			end
			
			if not (rover.fofflags & FOF_EXISTS) then
				return // doesn't exist
			end
				
			if not (rover.fofflags & FOF_SOLID) then
				return // non solid FOF
			end
			
			if not (rover.fofflags & FOF_BUSTUP) then
				return // non-bustable FOF
			end
			
			if not (rover.busttype) then
				return // no defined busttype
			end
			
			if (mobj.type == MT_SUPERSPONGE_FAKEMISSILE and rover.busttype >= 3) then
				return // never break super strong walls
			end
			
			fof = rover
	
			break
		end
		
		if not (fof) then
			continue // a valid FOF was not found
		end
		
		EV_CrumbleChain(sector, fof) 
	end
end
addHook("MobjLineCollide", SpongeMissileBlocked, MT_SUPERSPONGE_KARATEBOX)
addHook("MobjLineCollide", SpongeMissileBlocked, MT_SUPERSPONGE_FAKEMISSILE)

//
// LaunchedObjectCollision
//
// Handles collison when two objects collide
//
local function LaunchedObjectCollision(mo, thing)

	local spongebob
	local collidable
	
	collidable = (MF_ENEMY|MF_BOSS|MF_SHOOTABLE)
	
	if not (mo and mo.valid and (mo.flags & collidable) and thing and thing.valid and (thing.flags & collidable)) then
		return // check for damageable objects only.
	end
	
	if (mo.z > thing.z + thing.height)
	or (thing.z > mo.z + mo.height) then
		return // if we're not colliding, return.
	end
	
	if (mo.type == MT_PLAYER or thing.type == MT_PLAYER)
		return // never check for players
	end
	
	if (thing.rbflags != RBF_LAUNCHED) then
		return // not launched
	end
	
	// Get the last player who launched you.
	spongebob = thing.rbplayer
	
	// Upon colliding, bounce us off our hit object.
	thing.momx = $/4 * -1
	thing.momy = $/4 * -1
	
	// If we did damage, thrust back hit object as well.
	if P_DamageMobj(mo, thing, spongebob, 1) then
		mo.momx = thing.momx * -1
		mo.momy = thing.momy * -1
	end
	
	thing.rbflags = 0 // Reset Reef Blower flags.
end
addHook("MobjCollide", LaunchedObjectCollision)
addHook("MobjMoveCollide", LaunchedObjectCollision)

//
// ObstructCollision
//
// Handles collision for obstructing things.
//
local function ObstructCollision(mo, thing) 

	if not (mo and mo.valid and thing and thing.valid) then 
		return
	end
	
	if (mo.z > thing.z + thing.height)
	or (thing.z > mo.z + mo.height) then
		return // If we're not colliding, return.
	end
	
	if not (mo.rbflags == RBF_OBSTRUCT or mo.rblaunchtime) 
	and not (thing.rbflags == RBF_OBSTRUCT or thing.rblaunchtime)
		return // Only check for obstructing or launched objects.
	end
	
	return false
end
addHook("MobjMoveCollide", ObstructCollision)

//
// VacuumCollision
//
// Handles blower collision for colliding objects and missiles
//
local function VacuumCollision(blower, thing) 

	if not (blower and blower.valid and thing and thing.valid) then 
		return false
	end
	
	if (blower.z > thing.z + thing.height + 8*FRACUNIT)
	or (thing.z > blower.z + blower.height + 8*FRACUNIT) then
		return false // If we're not colliding, return.
	end
	
	if not P_IsMobjVacuumable(thing) then
		return false // not vacuumable
	end
	
	// The vacuum's hitbox is colliding with damageable object.
	if (thing.flags & (MF_ENEMY|MF_BOSS|MF_SHOOTABLE)) and not (thing.flags & MF_MISSILE) then
	
		local player = blower.target and blower.target.player or nil
		local obstructor = player and player.ssvars and player.ssvars.blower.obstructor or nil
	
		// If the obstructor in question is a player and they are currently spinning, try damaging the mobj.
		if (obstructor and obstructor.valid and obstructor.type == MT_PLAYER and obstructor.state == S_PLAY_ROLL) then
			P_DamageMobj(thing, obstructor, blower.target, 1, 0)
		end
	
		return false
	end
	
	if not (thing.flags & MF_MISSILE) then
		return false // not a missile
	end
	
	if not (thing.flags & MF_NOBLOCKMAP) then
		return false // if the missile is a collidable thing in blockmap, ignore it
	end
	
	P_SSVacuumCapture(blower, thing)
end
addHook("MobjCollide", VacuumCollision, MT_SUPERSPONGE_VACBOX)
addHook("MobjMoveCollide", VacuumCollision, MT_SUPERSPONGE_VACBOX)

//
// NetBoxCollision
//
// Handles net collision for colliding objects
//
local function NetBoxCollision(net, jellyfish) 

	local sponge
	local list 
	local is_collectible
	local ang_diff
	local same_plane
	
	list = supersponge_collectible_list

	if not (net and net.valid and jellyfish and jellyfish.valid and jellyfish != net.target) then
		return // Let's try to not get caught in our own nets
	end
	
	if not (net.target and net.target.player and net.target.player.valid) then
		return // Never collide unless a player is actually holding the net.
	end
	
	sponge = net.target.player
	ang_diff = AngleFixed(sponge.drawangle - R_PointToAngle2(net.target.x - net.target.momx, net.target.y - net.target.momy, jellyfish.x, jellyfish.y) + ANGLE_90)
	same_plane = not (net.target.z > jellyfish.z + jellyfish.height) and not (jellyfish.z > net.target.z + net.target.height)
	
	if (net.z > jellyfish.z + jellyfish.height + MAXSTEPMOVE)
	or (jellyfish.z > net.z + net.height + MAXSTEPMOVE) then
		return // If we're not colliding, return.
	end 

	if (same_plane and ang_diff > AngleFixed(ANGLE_180))  then
		return // the "jellyfish" is behind us.
	end

	if (list[jellyfish.type] and list[jellyfish.type] == 2 and (jellyfish.fuse > 7*TICRATE or BattleGametypeIsActive())) then
		return // Never collect flung collectibles unless 8 tics has passed since it spawned or BattleMod is inactive.
	end

	if not P_SSNetCapture(net, sponge, jellyfish) then
		P_DamageMobj(jellyfish, net, net.target, 1) // Damage incapturable targets.
	end
end
addHook("MobjMoveCollide", NetBoxCollision, MT_SUPERSPONGE_NETBOX)

//
// KarateBoxCollision
//
// Handles collision for the karate hitbox
//
local function KarateBoxCollision(glove, enemy) 

	local sponge
	local target

	if not (glove and glove.valid and enemy and enemy.valid and enemy != glove.target) then
		return // Don't accidentally strike yourself!
	end
	
	if not (glove.target and glove.target.valid and glove.target.player and glove.target.player.valid) then
		return // No active player is wielding this glove.
	end
	
	sponge = glove.target.player
	target = glove.target
	
	if (glove.z > enemy.z + enemy.height)
	or (enemy.z > glove.z + glove.height) then
		return // If we're not colliding, return.
	end 
	
	if P_PlayerInPain(sponge) then
		return // We're hit!
	end
	
	// Hit a spring, get sprung.
	if (sponge and (sponge.powers[pw_strong] & STR_SPRING) and (enemy.flags & MF_SPRING)) then
	
		P_DoSpring(enemy, target)

		return
	end
	
	// Smash spikes!
	if (sponge and (sponge.powers[pw_strong] & STR_SPIKE) and (enemy.type == MT_SPIKE or enemy.type == MT_WALLSPIKE)) then
		
		local spike
		local blockdist = enemy.radius + glove.radius
		
		// OH NO, not the distance checks!
		
		if (abs(enemy.x - glove.x) >= blockdist or abs(enemy.y - glove.y) >= blockdist)
			return // didn't hit it
		end
		// see if it went over / under
		if (glove.z > enemy.z + enemy.height)
			return // overhead
		end
		if (glove.z + glove.height < enemy.z)
			return // underneath
		end

		if (enemy.flags & MF_SOLID)
			S_StartSound(target, enemy.info.deathsound)
		end
		
		// for the love of neptune, please DO NOT kill the performance :^)
		for spike in mobjs.iterate() do
			if (spike.type == enemy.type 
			and spike.health > 0 
			and spike.flags & MF_SOLID
			and (spike == thing or P_AproxDistance(P_AproxDistance(enemy.x - spike.x, enemy.y - spike.y), enemy.z - spike.z) < 56*enemy.scale))
				P_KillMobj(spike, target, target, 0)
			end
		end
		
		return
	end
	
	if not (enemy and (enemy.flags & (MF_ENEMY|MF_BOSS|MF_SHOOTABLE)) and enemy.valid) then
		return // Not a damageable thing.
	end
	
	if (enemy.flags2 & MF2_FRET) then
		return // The enemy is already hit.
	end
	
	if not P_PlayerCanDamage(sponge, enemy) then
		return // The player cannot damage the target.
	end
	
	local damaged = P_DamageMobj(enemy, target, target, 1, 0)
	
	// Replicate knockback damage
	if (damaged and enemy.info.spawnhealth > 1) then
		target.momx = $ * -1
		target.momy = $ * -1
		if (sponge.charability == CA_FLY and sponge.panim == PA_ABILITY)
			target.momz = -target.momz/2
		elseif (sponge.pflags & PF_GLIDING and not P_IsObjectOnGround(target))
			sponge.pflags = $ & ~(PF_GLIDING|PF_JUMPED|PF_NOJUMPDAMAGE)
			target.state = S_PLAY_FALL
			target.momz = $ + P_MobjFlip(target) * (sponge.speed >> 3)
			target.momx = 7*target.momx>>3
			target.momy = 7*target.momy>>3
		elseif ((sponge.powers[pw_strong] & STR_DASH) and sponge.panim == PA_DASH)
			P_DoPlayerPain(sponge, enemy, enemy)
		end
	end

	P_RemoveMobj(glove)
end
addHook("MobjMoveCollide", KarateBoxCollision, MT_SUPERSPONGE_KARATEBOX)

//
// BalloonCollision
//
// Handles spike collision for the balloon
//
local function BalloonCollision(balloon, hazard) 

	local sponge
	local poink

	if not (balloon and balloon.valid and hazard and hazard.valid and P_IsBalloonHazard(hazard)) then
		return // Only check for hazards outside of the player.
	end
	
	poink = false
	
	if (balloon.z > hazard.z + hazard.height)
	or (hazard.z > balloon.z + balloon.height) then
		return // If we're not colliding, return.
	end

	P_KillMobj(balloon, hazard, nil, DMG_SPIKE) // Poink!
end
addHook("MobjMoveCollide", BalloonCollision, MT_SUPERSPONGE_BALLOON)

//
// VortexBubbleCollision
//
// Handles collision for the whirlpool bubbles
//
local function VortexBubbleCollision(bubble, thing)

	if not (bubble and bubble.valid and thing and thing.valid and thing != bubble.target) then
		return false
	end
	
	if not (thing.flags & (MF_ENEMY|MF_BOSS|MF_SHOOTABLE)) then
		return false // Not a damageable thing.
	end
	
	if (bubble.z > thing.z + thing.height)
	or (thing.z > bubble.z + bubble.height) then
		return false // If we're not colliding, return.
	end

	P_DamageMobj(thing, bubble, bubble.target, 1, DMG_WATER)
end
addHook("MobjMoveCollide", VortexBubbleCollision, MT_SUPERSPONGE_VORTEXBUBBLE)


///////////////////////////////////////////////
//			     Damage Hooks				//
/////////////////////////////////////////////


// SpongeDamage
//
// Damage handler for Spongebob / Other Mobjs
//
local function SpongeDamage(target, inflictor, source, damage, damagetype)

	local player = target.player
	local skin = target.skin
	local is_buttbouncing = (inflictor and inflictor.player and inflictor.player.ssvars and inflictor.player.ssvars.buttbounce) or false
	local is_whirlpooling = (inflictor and inflictor.player and inflictor.player.ssvars and inflictor.player.ssvars.whirlpooling) or false	
	local targetoftarget = target.target or nil

	if (target.health == 0) then
	
		// If the target died while being pulled by a Reef Blower, remove it.
		if (target.rbflags == RBF_OBSTRUCT and target.sucker and target.sucker.valid) then
			P_RemoveBlower(target.sucker.target.player)
		end
		
		target.rbflags = 0
	end

	// PLAYER TARGET
	if (player)
		
		local obstructor = player.ssvars.blower.obstructor
		
		// Remove any active hitboxes
		if (player.ssvars.hitbox and player.ssvars.hitbox.valid) then
			P_RemoveMobj(player.ssvars.hitbox)
		end
	
		if (P_IsSuperSponge(target.skin)) then
		
			local active_shield = SB_GetActiveShield(player)
			local active_stack = (player.powers[pw_shield] & SH_STACK)
		
			// Stop any active taunts.
			if P_IsDoingSpongeTaunt(player) then 
				S_StopSound(target)
			end
			
			// Touched an electric sector.
			if (damagetype == DMG_ELECTRIC) then
				S_StartSound(target, sfx_sbelec, target.player) // play electric shock
			end
			
			// As long as we are not currently wearing a shield, let our gear take damage for us.
			if (cv_powerups.value and active_shield and not player.powers[pw_shield] and player.mo.health > 0) then	
				
				local sound

				P_DoPlayerPain(player, source, inflictor) // Throw player back in fake hurt state.
				
				// As with the Armageddon Shield, the pie will instantly explode upon taking damage.
				if (active_shield == SS_POWERUP_PIE) then
					P_LaunchExplodingPie(player)
				else
					player.ssvars.powerups[active_shield] = $ - damage // decrease gear hp
				end
				
				// If wearing the water helmet, the hurt sound will be changed to glass shattering.
				if (active_shield == SS_POWERUP_HELMET) then
					sound = sfx_shattr
				else
					sound = sfx_shldls
				end
				
				if (damagetype == DMG_SPIKE) // spikes
					S_StartSound(target, sfx_spkdth)
				else
					S_StartSound (target, sound) // Ba-Dum! Shield loss.
				end

				if ((gametyperules & GTR_TEAMFLAGS) and (player.gotflag & (GF_REDFLAG|GF_BLUEFLAG)))
					P_PlayerFlagBurst(player, false)
					if (source and source.player)	
						// Award no points when players shoot each other when cv_friendlyfire is on.
						if (not G_GametypeHasTeams() or not (source.player.ctfteam == player.ctfteam and source != player.mo))
							P_AddPlayerScore(source.player, 25)
						end
					end
				end
				if (source and source.player and not player.powers[pw_super]) //don't score points against super players
					// Award no points when players shoot each other when cv_friendlyfire is on.
					if (not G_GametypeHasTeams() or not (source.player.ctfteam == player.ctfteam and source != player.mo))
						P_AddPlayerScore(source.player, 50)
					end
				end
				
				return true
			end
		end
		
		if not (player.mo.health == 0) then return end // Not dead yet.
		
		// Drop all weapons and gear upon death.
		if (P_IsSuperSponge(target.skin) and multiplayer and cv_powerups.value)
			P_RemoveSSPowerups(player, true, true) // * explosion *
		else
			P_RemoveSSPowerups(player, false) // don't drop anything
		end
				
		P_ResetSpongeVars(player, (G_CoopGametype() != true))
	end
	
	// OBJECT TARGET
	if (target and target.valid)	
		// If the balloon gets popped, make sure to remove it, so the player doesn't spawn it again.
		if (target.type == MT_SUPERSPONGE_BALLOON and targetoftarget and targetoftarget.player) then
			P_RemoveSSPowerup(targetoftarget.player, SS_POWERUP_BALLOON, false)
		end
		// If we were damaged by a jellyfishing net, knockback source.
		if (inflictor and inflictor.valid 
		and inflictor.type == MT_SUPERSPONGE_NETBOX
		and (target.info.spawnhealth > 1 or (target.flags & MF_MONITOR))) then
			source.momx = $ * -1
			source.momy = $ * -1
		end
	end
	
	// Don't try to bounce off of non-solid things.
	if not (target and target.flags & (MF_SOLID|MF_SHOOTABLE) and target.valid) then
		return
	end
	
	local spongebob
	
	// Get the "Spongebob" who inflicted damage on us.
	if (inflictor and inflictor.valid and source == nil) 
	or (inflictor and inflictor.valid and source and source.valid and inflictor == source) then
		spongebob = inflictor
	elseif (source and source.valid and inflictor == nil)
	or (inflictor and inflictor.valid and source and source.valid and source != inflictor) then
		spongebob = source
	end
	
	// If a player who is not Spongebob inflicted damage on us, return.
	if not (spongebob and P_IsSuperSponge(spongebob.skin) and spongebob.player) then 
		return 
	end
	
	local is_jumping = (spongebob.player.pflags & PF_JUMPED)
	local is_whirlpooling = P_IsWhirlpooling(spongebob.player)
	local item_chance = P_RandomChance(2*FRACUNIT/10) // %20 chance to spawn pickup
	local in_nights_mode = (spongebob.player.powers[pw_carry] == CR_NIGHTSMODE)

	// The attack was physical and not indirect.
	if (spongebob == inflictor and source == nil)
	or (spongebob == source and inflictor == nil)
	or (spongebob == source and spongebob == inflictor) then
		// Knock back players using the "Raging Whirlpool" against a boss.
		if (is_whirlpooling and (target.flags & MF_BOSS)) then
			spongebob.momx = $ * -1
			spongebob.momy = $ * -1
		elseif (is_jumping) then
			// Bounce the player upwards if butt-bouncing / whirlpooling.
			if P_IsButtBouncing(spongebob.player) then
				P_StopButtBounce(spongebob.player, false, true)	
			elseif P_IsWhirlpooling(spongebob.player) then
				spongebob.momz = $ + (8*FRACUNIT) * P_MobjFlip(spongebob)
			end
			// Always reset whirlpool flag for easy chaining
			if P_MobjFlip(spongebob) == P_MobjFlip(target) then P_StopRagingWhirlpool(spongebob.player) end
		end
	end

	// Don't try to drop any ammo if the player is in NIGHTS mode or powerups are disabled.
	if not (target.health <= 1 and (target.flags & MF_ENEMY) and item_chance and cv_powerups.value and not in_nights_mode) then		
		return
	end

	local ammotype
	
	// Pick one of two ammotypes at random.
	if P_RandomByte()&2 then
		ammotype = SS_POWERUP_JELLYJAR
	else
		ammotype = SS_POWERUP_BUBBLEJAR
	end
		
	P_SpawnSSPickup(target.x, target.y, target.z, ammotype, SS_PKTYPE_DESPAWN)
end
addHook("MobjDamage", SpongeDamage)
addHook("MobjDeath", SpongeDamage)

// SpongeDamageOverride
//
// ShouldDamage Handler for Spongebob
//
local function SpongeDamageOverride(target, inflictor, source, damage, damagetype)
	
	local player = target.player
	local skin = target.skin
	local friendlyfire = (CV_FindVar("friendlyfire")).value > 0 or 0
	local active_shield = 0

	// You cannot be damaged / damage your target if you are currently blocking a Reef Blower.
	if (target and target.valid and target.rbflags == RBF_OBSTRUCT and damagetype != DMG_INSTAKILL) then
		return false
	end
	
	// Someone is inflicting damage on us.
	if (inflictor and inflictor.valid) then
		local is_enemy = (inflictor.flags & MF_ENEMY)
		local is_missile = (inflictor.flags & MF_MISSILE)
		local same_target = (inflictor.target and target.target and inflictor.target == target.target or target.target == inflictor)	
		// In any of these cases, return false.
		if (inflictor.rbflags == RBF_LAUNCHED and target.type == MT_PLAYER) // launched enemies cannot damage players
		or (inflictor.rbflags == RBF_OBSTRUCT and is_enemy) // obstructing enemies cannot damage players
		or (inflictor.rbflags == RBF_SUCKED) // enemies who are currently being sucked into a blower cannot damage you
		or (target.type == MT_SUPERSPONGE_BALLOON and (same_target or is_missile and source == target.target)) // do not damage your own balloon
			return false 
		end
	end
	
	if not (P_IsSuperSponge(target.skin) and player and player.valid) then return end // Ignore, if we're not Spongebob.
	
	if (player.exiting) 
	or (player.powers[pw_flashing])
	or (player.powers[pw_carry] == CR_NIGHTSMODE)
	or (player.powers[pw_carry] == CR_NIGHTSFALL)
	or (player.pflags & PF_GODMODE) then 
		return // the player is invincible, in god mode, or in NIGHTS mode
	end
	
	// one tic invincibility while using the net in it's first frame
	if (target.state == S_PLAY_SSNET and inflictor and inflictor.valid) then
		return false
	end
	
	// The glasses, water helmet, space suit, pie, and boots all protect the player from damage.
	active_shield = SB_GetActiveShield(player)
	
	// The space suit prevents water / slime / fire damage.
	if (active_shield == SS_POWERUP_SUIT and (damagetype == DMG_WATER or damagetype == DMG_FIRE)) then
		return false
	end
	
	local floor
	local floorz
	local sector
	local shield
	
	if (P_MobjFlip(player.mo) == -1) then
		floor = target.ceilingrover
		floorz = target.ceilingz
	else
		floor = target.floorrover
		floorz = target.floorz
	end
	
	sector = floor and floor.valid and floor.master.frontsector or nil
	
	// The player was hurt by a source of fire.
	if (damagetype == DMG_FIRE and inflictor == nil and source == nil and not player.powers[pw_shield] and not player.powers[pw_super] and cv_deadlylava.value) then
	
		// Always kill Spongebob if he touches lava.
		if (floor and floor.valid)
		and (floor.fofflags & FOF_EXISTS)
		and (floor.fofflags & FOF_SWIMMABLE)
		and (sector.damagetype == SD_FIRE or sector.damagetype == SD_LAVA) 
		and (floor == target.floorrover and target.z <= floorz or floor == target.ceilingrover and target.z <= floorz) then	
			target.was_killed_by_lava = true
		end
		
		if (target.was_killed_by_lava) then P_DamageMobj(target, nil, nil, 1, DMG_INSTAKILL) target.momz = 0 return end
	end
	
	// Prevent spike / electrical damage with squeaky boots!
	if (P_IsPowerupActive(player, SS_POWERUP_BOOTS) and (damagetype == DMG_SPIKE or damagetype == DMG_ELECTRIC)) then	
		// We were damaged by the environment!
		if (inflictor == nil and source == nil and target.z == target.floorz) then
			return false
		// The inflictor was a spike hazard.
		elseif (inflictor and inflictor.valid and (inflictor.flags & MF_SOLID)) then
			// If we are currently standing on the spike hazard, do not damage the player.
			if (P_MobjFlip(target) == -1 and P_MobjFlip(inflictor) == -1 and target.z - target.height < inflictor.z)
			or (P_MobjFlip(target) == 1 and P_MobjFlip(inflictor) == 1 and target.z + target.height > inflictor.z) then
				return false
			end
		end
	end
end
addHook("ShouldDamage", SpongeDamageOverride)

///////////////////////////////////////////////
//			   Overlay Functions			//
/////////////////////////////////////////////

local function SB_GetPantsColor(sponge)

	local color

	// The Fire Flower overrides the player's pants color.
	if (sponge.powers[pw_shield] & SH_FIREFLOWER) then
		color = SKINCOLOR_RED
	else
		color = sponge.ssvars.pants.color
	end
	
	return color
end

local function SB_ShouldDisplayOverlay(sponge, type)

	local display = true
	local skin = sponge.mo.skin
	local sprite2 = sponge.powers[pw_super] and sponge.mo.sprite2 & ~FF_SPR2SUPER or sponge.mo.sprite2
	local frame = (sponge.mo.frame & FF_FRAMEMASK)
	local pantscolor = SB_GetPantsColor(sponge)
	
	 // Hide the overlay in NIGHTS mode.
	if (sponge.powers[pw_carry] == CR_NIGHTSMODE and sprite2 != SPR2_TRNS) then
		display = false
	end
	
	// The player is in their super form and is already transformed.
	if (sponge.powers[pw_super] and not (sprite2 == SPR2_TRNS and frame < E) or sprite2 == SPR2_TRNS and frame >= E) then
		display = false
	end
	
	// If the overlay's type is the pants, check if it can currently be displayed.
	if (type == "pants") then
	
		if (pantscolor == SKINCOLOR_NONE) then
			display = false
		end
		
		// The player is wearing the space suit.
		if (sponge.mo.skin == "supersponge_ss") then
			display = false
		end
	end
	
	// If powerups are turned off, do not show the blower nor the water helmet.
	if (type == "blower" and cv_powerups.value <= 0)
	or (type == "helmet" and skin != "supersponge_ss" and cv_powerups.value <= 0) then
		display = false
	end
		
	return display
end

local function SB_DoBlowerOverlay(player)
	
	local x, y
	local blower
	local hose
	local sprite
	local sprite2
	local prefix
	local suffix
	local scale
	local index
	local limit
	
	// No blower.
	if not (player.ssvars.blower.mo and player.ssvars.blower.mo.valid) then
		return 
	end
	
	blower = player.ssvars.blower.mo
	
	// Set angle
	blower.angle = player.drawangle
	
	// Try "pushing" the blower upwards to prevent removal from death pits.
	if (P_MobjFlip(player.mo) == -1) then
		blower.momz = player.mo.subsector.sector.floorheight - player.mo.z
	else
		blower.momz = player.mo.subsector.sector.ceilingheight - player.mo.z
	end

	// Don't display in the overlay during certain player states or statuses.
	if not SB_ShouldDisplayOverlay(player, "blower", nil) then blower.cusval = 100 blower.flags2 = $|MF2_DONTDRAW return end
	
	// If the blower was previously hidden, re-display it.
	if (blower.cusval == 100) then blower.cusval = 0 blower.flags2 = $ & ~MF2_DONTDRAW end
	
	// Update X and Y scale
	blower.spritexscale = player.mo.spritexscale/2
	blower.spriteyscale = player.mo.spriteyscale/2
	
	// Update X and Y offsets.
	blower.spritexoffset = player.mo.spritexoffset
	blower.spriteyoffset = player.mo.spriteyoffset
	
	// Set flags, flags2, renderflags, blendmode, etc.
	blower.flags = MF_SCENERY
	blower.flags2 = $|MF2_LINKDRAW
	blower.renderflags = player.mo.renderflags
	blower.blendmode = player.mo.blendmode
	blower.rollangle = player.mo.rollangle
	blower.mirrored = player.mo.mirrored
	blower.shadowscale = player.mo.shadowscale
	blower.colorized = player.mo.colorized
	
	// Set dispoffset.
	blower.dispoffset = 2
	
	if (player.powers[pw_super]) then
		sprite2 = player.mo.sprite2 & ~FF_SPR2SUPER
	else
		sprite2 = player.mo.sprite2
	end
	
	index = overlay_spr2_table["blower"][sprite2] != nil and overlay_spr2_table["blower"][sprite2][1] or 1
	limit = overlay_spr2_table["blower"][sprite2] != nil and overlay_spr2_table["blower"][sprite2][2] or 0
	
	if (index > 9) then
		prefix = "SPR_" + index
	else
		prefix = "SPR_0" + index
	end
	
	// Do not draw the sprite if the index is currently missing.
	if (overlay_spr2_table["blower"][player.mo.sprite2] == nil) then
		return
	end		
	
	// Use alternate blower sprites, if wearing the space suit.
	if (player.mo.skin == "supersponge_ss" and player.powers[pw_carry] != CR_NIGHTSMODE) then
		suffix = "B@"
	else
		suffix = "B#"
	end
	
	// Set blower sprite depending on active state and powerups.
	blower.sprite = _G[prefix + suffix] or SPR_NULL
	
	// Check the SPR2 table for the corresponding frame index
	if (overlay_spr2_table["blower"][sprite2] != nil) then
		if (player.mo.frame & FF_FRAMEMASK > limit) then
			blower.frame = player.mo.frame & ~(player.mo.frame & FF_FRAMEMASK) | limit
		else
			blower.frame = player.mo.frame
		end
	else
		blower.frame = A // default to frame A
	end
end

local function SB_DoHelmetOverlay(player, type)

	local color
	local helmet
	local sprite
	local prefix
	local index
	local limit
	
	// Did your helmet disappear?
	if not (player.ssvars.helmet and player.ssvars.helmet.valid) then return end
	
	helmet = player.ssvars.helmet
	
	// Try "pushing" the helmet upwards to prevent removal from death pits.
	if (P_MobjFlip(player.mo) == -1) then
		helmet.momz = player.mo.subsector.sector.floorheight - player.mo.z
	else
		helmet.momz = player.mo.subsector.sector.ceilingheight - player.mo.z
	end	

	// Don't display in the overlay during certain player states or statuses.
	if not SB_ShouldDisplayOverlay(player, "helmet") helmet.cusval = 100 helmet.flags2 = $|MF2_DONTDRAW return end
	
	// If the helmet was previously hidden, re-display it.
	if (helmet.cusval == 100) then helmet.cusval = 0 helmet.flags2 = $ & ~MF2_DONTDRAW end
	
	// If the player is wearing the space suit, change the helmet's sprite scale to accomodate.
	if (type == 2) then
		helmet.spritexscale = player.mo.spritexscale/4
		helmet.spriteyscale = player.mo.spriteyscale/4
	else
		helmet.spritexscale = player.mo.spritexscale * 16/10
		helmet.spriteyscale = player.mo.spriteyscale * 16/10
	end
	
	// Set sprite Y offset
	if (type == 2) then
		helmet.spriteyoffset = player.mo.spriteyoffset
	else
		helmet.spriteyoffset = player.mo.height/5 + (player.mo.momz < 0 and -player.mo.momz/2 or 0)
	end
	
	// Set flags, flags2, renderflags, blendmode, etc.
	helmet.flags = MF_SCENERY
	helmet.flags2 = $|MF2_LINKDRAW
	helmet.renderflags = player.mo.renderflags
	helmet.blendmode = player.mo.blendmode
	helmet.spriteroll = player.mo.spriteroll
	helmet.mirrored = player.mo.mirrored
	helmet.shadowscale = player.mo.shadowscale
	helmet.colorized = player.mo.colorized
	
	// Set dispoffset.
	helmet.dispoffset = 2

	// If we're wearing the space suit, then render the space helmet sprites instead.
	if (type == 2) then
	
		index = overlay_spr2_table["helmet"][player.mo.sprite2] and overlay_spr2_table["helmet"][player.mo.sprite2][1] or 1
		limit = overlay_spr2_table["helmet"][player.mo.sprite2] and overlay_spr2_table["helmet"][player.mo.sprite2][2] or 0
		
		if (index > 9) then
			prefix = "SPR_" + index
		else
			prefix = "SPR_0" + index
		end	
	
		// Do not draw the sprite if the index is currently missing.
		if (overlay_spr2_table["helmet"][player.mo.sprite2] == nil) then
			return
		end		
			
		// Set helmet sprite depending on active state and powerups.
		helmet.sprite = _G[prefix + "#L"] or SPR_NULL
		
		// Check the SPR2 table for the corresponding frame index
		if (overlay_spr2_table["helmet"][player.mo.sprite2] != nil) then
			if (player.mo.frame & FF_FRAMEMASK > limit) then
				helmet.frame = player.mo.frame & ~(player.mo.frame & FF_FRAMEMASK) | limit
			else
				helmet.frame = player.mo.frame
			end
		else
			helmet.frame = A // default to frame A
		end
		
		helmet.frame = $|FF_TRANS70
		
		return
	end
	
	helmet.sprite = SPR_SSD4
	helmet.frame = player.ssvars.powerups[SS_POWERUP_BLOWER] and C or B
end

local function SB_DoPantsOverlay(player)

	local pants
	local sprite
	local prefix
	local index
	local limit
	local color
	
	// Did your pants disappear?
	if not (player.ssvars.pants.mo and player.ssvars.pants.mo.valid) then return end
	
	pants = player.ssvars.pants.mo

	// Try "pushing" the pants upwards to prevent removal from death pits.
	if (P_MobjFlip(player.mo) == -1) then
		pants.momz = player.mo.subsector.sector.floorheight - player.mo.z
	else
		pants.momz = player.mo.subsector.sector.ceilingheight - player.mo.z
	end
	
	// If the current color option is none or nights sprites are active, do not display.
	if not SB_ShouldDisplayOverlay(player, "pants") pants.cusval = 100 pants.flags2 = $|MF2_DONTDRAW return end
	
	// If the pants was previously hidden, re-display it.
	if (pants.cusval == 100) then pants.cusval = 0 pants.flags2 = $ & ~MF2_DONTDRAW end

	// Set flags, flags2, renderflags, blendmode, etc.
	pants.flags = MF_SCENERY
	pants.flags2 = $|MF2_LINKDRAW
	pants.renderflags = player.mo.renderflags
	pants.blendmode = player.mo.blendmode
	pants.rollangle = player.mo.rollangle
	pants.mirrored = player.mo.mirrored
	pants.shadowscale = player.mo.shadowscale
	pants.colorized = player.mo.colorized
	
	// Set dispoffset.
	pants.dispoffset = 1
	
	index = overlay_spr2_table["pants"][player.mo.sprite2] and overlay_spr2_table["pants"][player.mo.sprite2][1] or 1
	limit = overlay_spr2_table["pants"][player.mo.sprite2] and overlay_spr2_table["pants"][player.mo.sprite2][2] or 0
	
	if (index > 9) then
		prefix = "SPR_" + index
	else
		prefix = "SPR_0" + index
	end
	
	// Do not draw the sprite if the index is currently missing.
	if (overlay_spr2_table["pants"][player.mo.sprite2] == nil) then
		return
	end
	
	// Set pants sprite depending on active state and powerups.
	pants.sprite = _G[prefix + "P@"] or SPR_NULL
	
	// Check the SPR2 table for the corresponding frame index
	if (overlay_spr2_table["pants"][player.mo.sprite2] != nil) then
		if (player.mo.frame & FF_FRAMEMASK > limit) then
			pants.frame = player.mo.frame & ~(player.mo.frame & FF_FRAMEMASK) | limit
		else
			pants.frame = player.mo.frame
		end
	else
		pants.frame = A // default to frame A
	end
	
	pants.color = SB_GetPantsColor(player)
end

rawset(_G, "SB_HandlePowerupObjects", function(sponge)

	local balloon = sponge.ssvars.balloon
	local balloon_active = P_IsPowerupActive(sponge, SS_POWERUP_BALLOON) and not sponge.powers[pw_super] and sponge.powers[pw_carry] != CR_NIGHTSMODE
	local pants_active = (sponge.ssvars.pants != nil)
	local blower_active = P_IsPowerupActive(sponge, SS_POWERUP_BLOWER)
	local helmet_active = (P_IsPowerupActive(sponge, SS_POWERUP_HELMET) or P_IsPowerupActive(sponge, SS_POWERUP_SUIT))
	
	// Balloon
	if (balloon_active and not (balloon and balloon.valid)) then
		SB_SpawnBalloon(sponge)
	end
	
	// Pants
	if (pants_active) then
	
		if not (sponge.ssvars.pants.mo and sponge.ssvars.pants.mo.valid) then
			SB_SpawnPantsOverlay(sponge)
		end
		
		SB_DoPantsOverlay(sponge)
	end
	
	// Helmet
	if (helmet_active) then	
	
		if not (sponge.ssvars.helmet and sponge.ssvars.helmet.valid) then
			SB_SpawnHelmetOverlay(sponge)
		end 
		
		SB_DoHelmetOverlay(sponge, sponge.ssvars.powerups[SS_POWERUP_SUIT] > 0 and 2 or 1)
	end
	
	// Blower
	if (blower_active) then
	
		if not (sponge.ssvars.blower.mo and sponge.ssvars.blower.mo.valid) then
			SB_SpawnBlowerOverlay(sponge)
		end
		
		SB_DoBlowerOverlay(sponge)
	end
end)

local function SB_StateOverlayThinker()
	local color
	local skincolor
	local frame
	local flipped
	local blower_active
	for p in players.iterate() do	
	
		// not alive or spectating
		if not (p.mo and p.mo.valid) then
			continue
		end
		// not spongebob
		if not P_IsSuperSponge(p.mo.skin) then
			continue 
		end
		
		color = p.mo.color
		skincolor = p.skincolor
		flipped = P_MobjFlip(p.mo)
		blower_active = P_IsPowerupActive(p, SS_POWERUP_BLOWER) and p.powers[pw_super] <= 0
		
		// For Spongebob, change his skincolor back to normal when using the Fire Flower.
		if (color == SKINCOLOR_WHITE and (p.powers[pw_shield] & SH_FIREFLOWER) and skincolor != SKINCOLOR_WHITE) then
			p.mo.color = p.skincolor
		end
		
		// If the reef blower is on, emit running noise.
		if (p.ssvars.blower.status == RB_STATUS_ON) then
			p.ssvars.blower.noise = $ + 1
			if (p.ssvars.blower.noise == 1)
				S_StartSound(p.mo, sfx_rbstrt)
			elseif (p.ssvars.blower.noise == 17697/500) 
			or (p.ssvars.blower.noise > 17697/500 and (p.ssvars.blower.noise % 8*TICRATE) == 0) // or TICRATE and 394 miliseconds
				S_StartSound(p.mo, sfx_rbrun)
			end
		else
			if S_SoundPlaying(p.mo, sfx_rbstrt)
			or S_SoundPlaying(p.mo, sfx_rbrun) then
				S_StopSoundByID(p.mo, sfx_rbstrt)
				S_StopSoundByID(p.mo, sfx_rbrun)
			end
		end
	
		frame = (p.mo.frame & FF_FRAMEMASK)
		
		// At the end of SPR2_BNCE, keep frame on H
		if (p.mo.state == S_PLAY_SSBNCE_END) then
			p.mo.frame = $|H
		end
		// At the end of S_PLAY_DRWN, play S_PLAY_DRWN_END
		if (p.mo.state == S_PLAY_DRWN) then
			if (frame == A) then
				p.mo.flags = $ & ~MF_NOCLIPHEIGHT
			elseif (frame == I) then
				p.mo.state = S_PLAY_DRWN_END
			end
		end
		// For S_PLAY_DRWN_END, keep frame on I
		if (p.mo.state == S_PLAY_DRWN_END) then
			p.mo.frame = $|I
			p.mo.fuse = 2
		end
		
		// Use an alternate walking state for the blower.
		if (blower_active) then
			// Check for S_PLAY_WALK_BLOWER
			if (p.mo.state != S_PLAY_WALK_BLOWER and (p.mo.state == S_PLAY_WALK or p.mo.state == S_PLAY_RUN)) then
				p.mo.state = S_PLAY_WALK_BLOWER
			elseif (p.mo.state == S_PLAY_WALK_BLOWER and not p.rmomx and not p.rmomy)
				p.mo.state = S_PLAY_STND
			end
		elseif (p.mo.state == S_PLAY_WALK_BLOWER) then
			p.mo.state = S_PLAY_STND
		end
		
		// If the player was killed by lava, make them slowly descend beneath the surface of it.
		if (p.mo.was_killed_by_lava) then
		
			local floorz = flipped and p.mo.ceilingz or p.mo.floorz
			local floor_diff = FixedInt(FixedHypot(p.mo.z, floorz))
		
			// The player might still be alive!
			if (p.playerstate == PST_LIVE) then
				p.mo.was_killed_by_lava = false // What the scallop?! How did you live?
			elseif (floor_diff >= 128*FRACUNIT) then
				p.mo.momz = $ + ((flipped * p.mo.momz)/8) // In magma, you slowly fall while dying.
			end
		end
		
		SB_HandlePowerupObjects(p)
	end
end
addHook("PostThinkFrame", SB_StateOverlayThinker)


///////////////////////////////////////////////
//			   Player Functions		        //
/////////////////////////////////////////////


// SB_StopWeaponFire
// Prevents the firing of weapon rings during powerup actions as well as handling menu input.
local function SB_StopWeaponFire()
	for spongebob in players.iterate() do
	
		local has_gear
		local in_menu
		local is_blowing
		local is_shooting
		local is_jellyfishing
		local is_zapping
		local is_holding_fire
		local is_supersponge
	
		if not (spongebob.mo and spongebob.mo.valid) continue end // non-existent
		
		has_gear = P_GetCurrentSSGear(spongebob) > 0
		in_menu = SB_StopPlayerInput(spongebob) // in menu
		is_supersponge = P_IsSuperSponge(spongebob.mo.skin) // spongebob skin
		
		 // Never play the Pity / Pink shield SFX when powerups are enabled!
		if (is_supersponge and cv_powerups.value > 0 and S_SoundPlaying(spongebob.mo, sfx_shield)) then 
			S_StopSoundByID(spongebob.mo, sfx_shield)
		end
		
		 // Spongebob's variables are not fully initalized or the menu is open.
		if not (is_supersponge and spongebob.ssvars.is_spongebob and spongebob.ssvars != nil and not in_menu) then 
			continue
		end

		is_blowing = (P_IsReefBlowing(spongebob) or P_IsBlowingBubbles(spongebob) or spongebob.ssvars.blower.status >= 2)
		is_shooting = P_IsShooting(spongebob)
		is_jellyfishing = P_IsJellyfishing(spongebob)
		is_zapping = P_IsZapping(spongebob)
		is_holding_fire = spongebob.ssvars.spinbtntimer > 0 and P_IsPowerupActive(spongebob, SS_POWERUP_LAUNCHER)
		
		// Doing this because Ringslinger NEO prevents the blower from firing its projectiles.
		if (spongebob.cmd.buttons & BT_ATTACK) then
			spongebob.ssvars.pressedfire = true
		else
			spongebob.ssvars.pressedfire = false
		end
		
		// If the player is doing absolutely nothing, continue.
		if not (is_blowing or is_shooting or is_jellyfishing or is_zapping or is_holding_fire) then 
			continue
		end
		
		// If the player is playing Ringslinger NEO, delay shooting by 8 miliseconds.
		if (RingSlinger and (gametyperules & GTR_RINGSLINGER or CV_FindVar("ringslinger").value)) then
			spongebob.mo.ringslinger.weapondelay = 8
		else
			spongebob.weapondelay = 2
		end
	end
end
addHook("PreThinkFrame", SB_StopWeaponFire)

//
// SB_CheckSkinSwitch
//
// Handles switching between skins
//
local function SB_CheckSkinSwitch(player)

	local on
	local oldgear
	
	// print("Switching to " .. skins[player.mo.skin].realname) 
	
	if P_IsSuperSponge(player.mo.skin) then		
	
		// If powerups were turned on, get your gear back from the shield.
		if (cv_powerups.value) then
			SB_GetPowerupFromShield(player) 
		end
	
		player.ssvars.is_spongebob = true
	else		
		// Remove the blower, if it is still active.
		P_RemoveBlower(player)
		
		// Set blower walking animation back to S_PLAY_WALK
		if (player.mo.state == S_PLAY_WALK_BLOWER) then
			player.mo.state = S_PLAY_WALK
		end
	
		// If powerups were turned on, get your shield back from your gear.
		if (cv_powerups.value) then
			SB_GetShieldFromPowerup(player) // Get shield back from equipment.
		end
				
		P_SpawnShieldOrb(player) // Re-spawn shield orb
	
		player.ssvars.realshield = 0 // Reset real shields
		
		P_ResetSpongeVars(player, false) // Reset variables
	end
	
    // Don't try to toggle pickups in multiplayer!
	if (multiplayer) then 
		return
	end
	
	// If both pickups and powerups are on, replace all active monitors with pickups.
	if (player.ssvars.is_spongebob and (cv_pickups.value and cv_powerups.value)) then
		on = true
	else
		on = false
	end
	
	ToggleSSPickups(player, on)
end

//
// SB_CheckActiveSkin
//
// Checks which skin should be active while playing as Spongebob.
//
local function SB_CheckActiveSkin(player)

	local skin
	
	// In SRB2 Battle, don't override the player's skin choices until they can act.
	if (CBW_Battle and CBW_Battle.PreRoundWait()) then
		return
	end
	
	// Change player's skin depending on active powerup.
	if P_IsPowerupActive(player, SS_POWERUP_SUIT) then
		skin = "supersponge_ss"
	elseif P_IsPowerupActive(player, SS_POWERUP_GLASSES) then
		skin = "supersponge_gl"
	else
		skin = "supersponge"	
	end
	
	if not R_SkinUsable(player, skin) then
		return // if skin is forced to not be used, then ignore anyways
	end
	
	if (player.mo.skin == skin) then
		return // already set
	end
		
	if (player.cr_skin != nil) then
		player.cr_skin = skin // Set UltRandomizer Skin
	end
		
	if (player.randomizer != nil) then
		player.randomizer.skin = #skins[skin] // Set Randomizer Skin
	end
	
	R_SetPlayerSkin(player, skin)
end

local blink_table = {
	[S_PLAY_WAIT] = {[9] = 1},
	[S_PLAY_FALL] = {[36] = 1, [47] = 1, [60] = 1},
	[S_PLAY_RIDE] = {[16] = 1}
}


//
// Dummy HUD for Camera Angle Variable
//
addHook("HUD", function(v, sponge, cam)

	if (sponge.mo.skin != "supersponge")
	and (sponge.mo.skin != "supersponge_gl")
	and (sponge.mo.skin != "supersponge_ss") then
		return // not spongebob
	end
	
	sponge.ssvars.camangle = cam.angle // get camera angle for blink
end, "game")

//
// SB_CheckSpongeBlink
//
// Handles Spongebob's blinking
//
local function SB_CheckSpongeBlink(sponge)

	local ang
	local state
	local frame
	local is_blinking
	
	// Only check for blinking in these states.
	if (sponge.mo.state != S_PLAY_WAIT)
	and (sponge.mo.state != S_PLAY_FALL) 
	and (sponge.mo.state != S_PLAY_RIDE) then
		return false
	end
	
	// Our camera hasn't initalized.
	if not (sponge.ssvars.camangle) then
		return false
	end
	
	ang = abs(sponge.ssvars.camangle - sponge.drawangle) or 0
	state = sponge.mo.state
	frame = (sponge.mo.frame & FF_FRAMEMASK)
	is_blinking = blink_table[state] != nil and blink_table[state][frame] or 0
	
	// Reset the blinking variable, if it was previously set.
	if (sponge.mo.didblink and not is_blinking) then
		sponge.mo.didblink = false
	end
	
	// Don't play the sound, if we're not already facing the camera.
	if (ang < ANGLE_90 and ang > ANGLE_270) then 
		return false
	end
	
	// Only check on the first tic of state.
	if not (is_blinking and not sponge.mo.didblink) then
		return false
	end
	
	sponge.mo.didblink = true
	
	return true
end

//
// SB_DoFootsteps
//
// Handles Spongebob's footsteps
//
local function SB_DoFootsteps(player)

	local frame = 0
	local footstep = 0
	local walk_frames = {[1] = 1, [5] = 2}
	local run_frames = {[2] = 1, [10] = 2}
	local step_sounds = {sfx_sbwlk1, sfx_sbwlk2, sfx_sbwlk3, sfx_sbwlk4}
	local playeronly = false
	
	frame = (player.mo.frame & FF_FRAMEMASK)
	
	if (player.mo.state == S_PLAY_RUN and frame != A) then
		footstep = run_frames[frame] != nil and run_frames[frame] or 0
	elseif ((player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_WALK_BLOWER) and frame != A and player.mo.tics == 2) then
		footstep = walk_frames[frame] != nil and walk_frames[frame] or 0
	end
	
	if not (footstep and cv_footsteps.value) then return end // no squeak noise... :(
	
	// The boots are active, so use the squeaky noises to inform the player that they have it.
	if P_IsPowerupActive(player, SS_POWERUP_BOOTS) then
		footstep = $ + 2
	end
	
	// In gametypes such as Tag or Hide and Seek, make sure that the player can only hear their footsteps!
	if G_TagGametype() then
		playeronly = true
	end
	
	S_StartSound(player.mo, step_sounds[footstep], playeronly and player or nil) 
end

//
// SB_JumpCheck
//
// Handles jump count, player flags, and buttbouncing.
//
local function SB_JumpCheck(sponge)

	// Can't buttbounce in these states
	if P_CanSpongeBounce(sponge)
		sponge.ssvars.canbounce = true
	else
		sponge.ssvars.canbounce = false
	end

	// Reset jump count and various flags
	if P_IsObjectOnGround(sponge.mo)
		sponge.ssvars.jmpcount = 0
		sponge.ssvars.whirlpooling = false
		sponge.ssvars.whirlpooltimer = 0
		sponge.ssvars.airchopping = false
	end
	
	// Check if jump was held down the last frame.
	if (sponge.pflags & PF_JUMPDOWN)
		sponge.ssvars.jmpbtntimer = $+1
	else
		sponge.ssvars.jmpbtntimer = 0
	end
	
	// Check if we are holding the jump button for at least 2 or more miliseconds
	if (sponge.ssvars.jmpbtntimer >= 2)
		// Yep, we are holding jump.
		sponge.ssvars.holdingjump = true
	else
		// Not holding it at all.
		sponge.ssvars.holdingjump = false
	end
	
	if P_IsMovementLocked(sponge) return end
	
	// So if we jumped and we're not holding jump, count the jumps!
	if not (sponge.cmd.buttons & BT_JUMP and not sponge.ssvars.holdingjump)
		// Check whether our jump count is lower than 2 and we can bounce
		if (sponge.ssvars.jmpcount < 2 and sponge.ssvars.canbounce)
			sponge.ssvars.jmpcount = $+1
		end
	end	
end

//
// SB_HydrationCheck
//
// Spongebob's hydration function
//
local function SB_HydrationCheck(sponge)

	// Never set in SRB2infinity.
	if PSOIsEnabled() then
		return
	end

	// If the player is underwater, set the hydration flag.
	if (sponge.mo.eflags & MFE_UNDERWATER) and not (sponge.mo.eflags & MFE_TOUCHLAVA) then
		
		local is_hydrated = (sponge.ssvars.hydrated and sponge.ssvars.hydratedtics <= HYDRATION_TIME - 1)

		// Lower by 1 tic to prevent the hydration effect on spawn.
		if (is_hydrated) then
			sponge.ssvars.hydratedtics = HYDRATION_TIME - 1
		else
			sponge.ssvars.hydrated = true
			sponge.ssvars.hydratedtics = HYDRATION_TIME
		end
			
		sponge.powers[pw_underwater] = 0 // Unlimited breath underwater
	end
	
	if (sponge.mo.eflags & MFE_UNDERWATER) then return end // still underwater!
	
	if not (sponge.ssvars.hydrated) then return end // not hydrated
	
	local bubble
	
	// On the first tic of the timer, play the "hydration" sound effect.
	if (sponge.ssvars.hydratedtics == HYDRATION_TIME) then
		S_StartSound(sponge.mo, sfx_sbspls)
	elseif (sponge.ssvars.hydratedtics % 2 == 0 and sponge.speed > 0) then

		bubble = P_SpawnMobj(sponge.mo.x + (P_RandomRange(-16, 16)*FRACUNIT), 
							 sponge.mo.y + (P_RandomRange(-16, 16)*FRACUNIT), 
							 sponge.mo.z + sponge.mo.height/3, MT_THOK)
			
		// Choose between a medium-sized bubble or small bubble at random.
		if (P_RandomByte() > 128) then 
			bubble.state = S_SUPERSPONGE_FAKEBUBBLE
		else
			bubble.state = S_SUPERSPONGE_FAKEBUBBLE_MEDIUM
		end
		
		bubble.color = SKINCOLOR_WHITE
		bubble.colorized = true
		bubble.fuse = 8
	end

	// Deduct hydration timer.
	if (sponge.ssvars.hydratedtics > 0) then
	
		sponge.ssvars.hydratedtics = $ - 1
		
		return
	end
	
	sponge.ssvars.hydrated = false
end

//
// SB_HandleSpeedStats
//
// Sets Spongebob's speed depending on his current stats.
//
local function SB_HandleSpeedStats(sponge)
	
	local normalspeed
	local runspeed
	local acceleration
	local a, b, c
	
	// Never set in SRB2infinity.
	if PSOIsEnabled() then
		return
	end

	normalspeed = FixedInt(skins[sponge.mo.skin].normalspeed)
	runspeed = FixedInt(skins[sponge.mo.skin].runspeed)
	acceleration = skins[sponge.mo.skin].acceleration
	
	// Set the sponge's speed stats depending if they are underwater or hydrated.
	if (sponge.mo.eflags & MFE_UNDERWATER) and not (sponge.mo.eflags & MFE_TOUCHWATER) then	
	
		a = (normalspeed<<1)*FRACUNIT
		b = runspeed*FRACUNIT
		c = acceleration
		
	elseif (sponge.ssvars.hydrated) then
		
		if (sponge.powers[pw_sneakers] or sponge.powers[pw_super])
			a = (12 * normalspeed / 10)*FRACUNIT	
		else
			a = (15 * normalspeed / 10)*FRACUNIT
		end
		
		b = a - 8*FRACUNIT
		c = acceleration
	else
		a = normalspeed*FRACUNIT
		b = runspeed*FRACUNIT
		c = acceleration
	end
	
	// already updated
	if (sponge.normalspeed == a)
	and (sponge.runspeed == b)
	and (sponge.acceleration == c) then		
		return
	end
	
	sponge.normalspeed = a
	sponge.runspeed = b
	sponge.acceleration = c
end

//
// SB_HandleJumpStats
//
// Sets Spongebob's jump height based on his current stats
//
local function SB_HandleJumpStats(sponge)
	
	local heavy
	local light
	local jumpfactor
	local newfactor
	
	// Never set in SRB2infinity.
	if PSOIsEnabled() then
		return
	end

	heavy = P_IsPowerupActive(sponge, SS_POWERUP_BLOWER) and not sponge.powers[pw_super]
	light = P_IsPowerupActive(sponge, SS_POWERUP_BALLOON) and not sponge.powers[pw_super]
	jumpfactor = skins[sponge.mo.skin].jumpfactor
	newfactor = jumpfactor

	if (heavy) then
		newfactor = 8*jumpfactor/10 // The blower makes you heavier.
	elseif (light) then
		newfactor = jumpfactor + 10*FRACUNIT/100 // The balloon makes you lighter.
	end
	
	// already updated
	if (sponge.jumpfactor == newfactor) then
		return
	end
	
	sponge.jumpfactor = newfactor // Set new jump factor.
end

//
// SpongebobThink
//
// Main thinking function.
//
local function SpongebobThink(player)
	
	local skin
	local gear
	local shield
	local normalspeed
	local runspeed
	local acceleration
	local jumpfactor
	local onground
	local canstand 
	local cantarget
	local thing
	local pressedjump
	
	// Neither alive or present.
	if not (player.mo and player.mo.valid) then return end
	
	// skin variables
	skin = player.mo.skin
	normalspeed = FixedInt(skins[player.mo.skin].normalspeed)
	runspeed = FixedInt(skins[player.mo.skin].runspeed)
	acceleration = skins[player.mo.skin].acceleration
	jumpfactor = skins[player.mo.skin].jumpfactor
	
	P_UpdateClamArray(player) // Since clams can target players other than Spongebob, update the array here.
	
	// So you like krabby patties, do ya?
	if (player.mo.state == S_PLAY_KRAB and (P_IsMovementLocked(player) or player.speed > 0)) then
		player.mo.state = S_PLAY_FALL // Stop the animation, if we are stuck or currently moving.
	end
	
	// The player is obstructing another player's reef blower	
	if (player.mo.sucker and player.mo.sucker.valid and (player.mo.rbflags & RBF_OBSTRUCT)) then
		
		local flip = P_MobjFlip(player.mo)
		local jumping = 0
		local free = false
		local otherplayer = player.mo.sucker.target.player
	
		jumping = player.bot == 0 and (player.cmd.buttons & BT_JUMP) or false // only real players can free themselves

		// initalize dummy variable or something
		if (player.dummyyvar == nil) then
			player.dummyyvar = 0
		end

		if (jumping) then
			player.dummyyvar = $ + 1
		else
			player.dummyyvar = 0
		end
		
		// If the blower has SOMEHOW disappeared, remove yourself at once.
		if not (player.mo.sucker and player.mo.sucker.valid) then
			free = true
		end
		
		// Every time the player presses JUMP, they have a 15% chance of getting free.
		if (player.dummyyvar == 2) then
		
			player.mo.momz = $ + (5 * flip)*FRACUNIT // upward movement for animation
			
			// we're free!
			if (P_RandomChance(15*FRACUNIT/100)) then
				free = true
			end
			
			S_StartSound(player.mo, sfx_s3k55)
		end
		
		if (free) then 
			P_RemoveBlower(otherplayer)
		end
		
		return
	end
	
	// Something's wrong, we're not Spongebob.
	if (P_IsSuperSponge(skin) == true and player.ssvars and not player.ssvars.is_spongebob) 
	or (P_IsSuperSponge(skin) == false and player.ssvars and player.ssvars.is_spongebob) then
		return SB_CheckSkinSwitch(player) // Handle switching between skins
	end

	if not P_IsSuperSponge(skin) then 
		return // Because sanity checks are cool!
	end
	
	local balloon_active = P_IsPowerupActive(player, SS_POWERUP_BALLOON)
	local blower_active = P_IsPowerupActive(player, SS_POWERUP_BLOWER) and player.powers[pw_super] <= 0
	local net_active = P_IsPowerupActive(player, SS_POWERUP_NET)
	local launcher_active = P_IsPowerupActive(player, SS_POWERUP_LAUNCHER)
	
	SB_JumpCheck(player) // Jump check
	SB_CheckActiveSkin(player) // Skin check
		
	gear = P_GetCurrentSSGear(player)
	
	if (gear)  then
		shield = supersponge_powerup_info[gear].shield
	else
		shield = -1
	end
	
	onground = P_IsObjectOnGround(player.mo)
	
	// If the player is actively walking or running, play footstep sounds
	if (onground and player.speed != 0 and cv_footsteps.value) then
		SB_DoFootsteps(player)
	end
	
	// If we blinked while facing the camera, cue the sound effect.
	if SB_CheckSpongeBlink(player) then
		S_StartSound(player.mo, sfx_sbblnk, player)
	end
	
	// Speed up running / edge animation for Spongebob
	if (player.mo.state == S_PLAY_RUN and player.mo.tics > 1) then
		player.mo.tics = $ - 1
	elseif (player.mo.state == S_PLAY_EDGE and player.mo.tics > 1) 
		player.mo.tics = $ - 2
	end

	SB_HandleSpeedStats(player)
	SB_HydrationCheck(player)
	
	if (srb2p) then return end // shhh.. we're playing persona!
	
	// Don't move during these states.
	if P_IsChopping(player)
	or P_IsJellyfishing(player)
	or P_IsBlowingBubbles(player) 
	or P_IsShooting(player)
	or P_IsZapping(player) then
		player.weapondelay = 1
		player.pflags = $|PF_FULLSTASIS
	else
		// Run shoot timer.
		if (player.ssvars.shoottimer) then
			player.ssvars.shoottimer = $ - 1
		end
		// Run melee timer.
		if (player.ssvars.meleetimer) then
			player.ssvars.meleetimer = $ - 1
		end
		// Stop fishing.
		if (player.ssvars.fishing) then
			player.ssvars.fishing = false
		end	
		// Stop chopping.
		if (player.ssvars.chopping) then
			player.ssvars.chopping = false
			player.powers[pw_strong] = STR_NONE
		end	
	end
	
	canstand = (not player.mo.standingslope or (player.mo.standingslope.flags & SL_NOPHYSICS) or abs(player.mo.standingslope.zdelta) < FRACUNIT/2)
	cantarget = (player.powers[pw_super] > 0 or P_IsPowerupActive(player, SS_POWERUP_LAUNCHER) and player.ssvars.ammo["jellyfish"] > 0)

	// Only target enemies and monitors in your super form or if you have ammo in the jellyfish launcher.
	if (onground and not player.ssvars.shoottimer and canstand and cantarget) then
		P_SpongeLockOn(player)
	end

	/// SHRINK RAY /// 
	
	// If the player is firing the shrink-ray, check if they are still super and pressing CUSTOM1.
	if (P_IsZapping(player) and not (player.powers[pw_super] and player.cmd.buttons & BT_CUSTOM1))
	or (P_IsZapping(player) and player.mo.state != S_PLAY_MZAP) then
		
		player.ssvars.zapping = false
		
		// Stop playing-shrink ray sfx
		if S_SoundPlaying(player.mo, sfx_sbsray) then
			S_StopSoundByID(player.mo, sfx_sbsray)
		end
		
		// Reset shrink-ray frame and tics
		player.ssvars.rayframe = 0
		player.ssvars.raytics = 2
	end
	
	thing = player.ssvars.lockon
	
	// Activate the shrink-ray!
	if (player.powers[pw_super] and (player.cmd.buttons & BT_CUSTOM1) and thing and thing.valid) then
		
		local x, y, raypoint	
		
		player.mo.state = S_PLAY_MZAP
		player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, thing.x, thing.y)
		player.drawangle = player.mo.angle
		player.weapondelay = 1

		x = P_ReturnThrustX(player.mo, player.drawangle, 16*FRACUNIT)
		y = P_ReturnThrustY(player.mo, player.drawangle, 16*FRACUNIT)
			
		raypoint = P_SpawnMobjFromMobj(player.mo, x, y, player.mo.height/5, MT_RAY)
		raypoint.state = S_SUPERSPONGE_SHRINKRAY
	
		// Animate frames by setting tics
		if (player.ssvars.raytics) then
			player.ssvars.raytics = $ - 1
		else
			if (player.ssvars.rayframe < 3) then
				player.ssvars.rayframe = $ + 1
			else
				player.ssvars.rayframe = 0
			end
			player.ssvars.raytics = 2
		end
		
		// play shrink ray sfx
		if not S_SoundPlaying(player.mo, sfx_sbsray) then
			S_StartSound(player.mo, sfx_sbsray)
		end
		
		R_DrawShrinkRay(player, raypoint, thing)
		
		// Only shrink the mobj if it is above a FRACUNIT/2 and it is not currently shrinking
		if (thing.scale == thing.destscale and thing.scale > FRACUNIT/2) then	
			// For bosses, keep track of whether they have been zapped or not
			if not (thing.supersponge_zapped) then
				thing.supersponge_zapped = true
				thing.supersponge_zaptics = 3*TICRATE
				thing.supersponge_oldscale = thing.scale
			end
			thing.scale = $ - FRACUNIT/16
		end
		
		player.ssvars.zapping = true
	end
	
	// If the player is in their super form, they can summon clams with BT_CUSTOM2!
	if (player.powers[pw_super] and player.cmd.buttons & BT_CUSTOM2 and player.ssvars.shoottimer <= 0) then

		local otherplayer
		
		// If we are playing multiplayer, try searching other players in the same distance.
		if (multiplayer) then
			otherplayer = P_FindNearestPlayer(player.mo, false, MELEERANGE)
		end
		
		// Summon the clams for the other player, if nearby or ourselves.
		if (otherplayer and otherplayer.valid and P_SummonClams(otherplayer) or player and P_SummonClams(player)) then	
			player.ssvars.shoottimer = SS_KARATE_COOLDOWN*2
		end
	end
	
	/// POWERUPS ///
	if (player.powers[pw_super] <= 0 and player.ssvars.powerups and P_GetSSPowerupCount(player) > 0 and cv_powerups.value > 0) then
	
		local pressedfire = (player.ssvars.pressedfire)
		local releasedspin = not (player.cmd.buttons & BT_SPIN)
		local isheavy = (blower_active or player.ssvars.buttbounce)
		local isstuck = P_IsMovementLocked(player)
		local is_walk_run_anim = (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN)
		
		if (blower_active and not P_IsReefBlowing(player) and not isstuck) then
			// Fire objects from the projectiles if the blower is not on and it is currently not cooling down.
			if (pressedfire and player.ssvars.blower.status != RB_STATUS_ON and not player.ssvars.blower.cooldown) then
				P_LaunchVacuumItem(player)
			end
		elseif (net_active and not P_IsJellyfishing(player) and not isstuck) then
			// If there are items in your Jellyfishing Net, release them.
			if (pressedfire and P_GetNetCount(player) > 0 and not player.ssvars.shoottimer) then
				P_UseJellyfishNet(player, true)
			end			
		elseif (launcher_active and not P_IsShooting(player) and not isstuck) then
			// If we held the SPIN button long enough, fire the launcher.
			if (P_CanShootJellyfish(player) and player.ssvars.spinbtntimer >= 2 and releasedspin) then
				// The player reached the maximum time necessary for a triple shot.
				if (player.ssvars.spinbtntimer >= SS_LAUNCHER_MAX_TIME) then
					player.ssvars.tripleshot = true
				else
					player.ssvars.tripleshot = false
				end
				player.mo.state = S_PLAY_SSGUN
			end
		end
		
		// The balloon is currently out.
		if (balloon_active) 
			// If we're falling and we're in our walking / running state, set our state to falling.
			if (player.mo.momz < 0 and not isstuck and is_walk_run_anim and not isheavy) then
				player.mo.state = S_PLAY_FALL
			end
			// Only slow the player's falling speed if they are actually falling and not being weighed down.
			if (player.mo.state == S_PLAY_FALL and player.mo.momz < 0 and not isheavy) then
				if (player.mo.eflags & MFE_UNDERWATER) then
					player.mo.momz = $ - $/16 // lower by an sixteenth of your current falling speed
				else
					player.mo.momz = $ - $/8 // lower by an eighth of your current falling speed
				end
			end
		end
		
		if (pressedfire) then player.pflags = $|PF_ATTACKDOWN end
	end
	
	// Spongebob can breathe in space with the water helmet, space suit, or while super.
	if (cv_powerups.value and (shield == SH_ELEMENTAL or shield == SH_PINK) or player.powers[pw_super]) then
		player.powers[pw_spacetime] = 0
	end

	SB_HandleJumpStats(player, blower_active)
	
	// Deduct the player's cooldown timer.
	if (player.ssvars.blower.cooldown) then
		player.ssvars.blower.cooldown = $ - 1
	end
	
	// The blower is currently not off.
	if (player.ssvars.blower.status > RB_STATUS_OFF or player.ssvars.blower.hitbox and player.ssvars.blower.hitbox.valid)
		
		local obstructor = player.ssvars.blower.obstructor or nil
		
		// If we stopped using the blower, remove it.
		if (P_IsPowerupActive(player, SS_POWERUP_BLOWER) != true)
		or (P_IsMovementLocked(player) and player.mo.state != S_PLAY_SPRING)
		or (player.ssvars.blower.status != RB_STATUS_STUCK and player.ssvars.spinbtntimer <= 0) 
		or (player.ssvars.blower.status == RB_STATUS_STUCK and obstructor and not obstructor.valid) then
			P_RemoveBlower(player)
		end
	end
	
	// If spin was held down the previous frame, add to timer.
	if (player.pflags & PF_SPINDOWN) and player.powers[pw_super] <= 0 then
		player.ssvars.spinbtntimer = $+1
	else
		player.ssvars.spinbtntimer = 0
	end
	
	// SPRING ANIMATION // 
	if (player.mo.state == S_PLAY_SPRING)
	
		// Reset the player's whirlpool variables.
		if not P_IsWhirlpooling(player) then
			player.ssvars.whirlpooling = false
			player.ssvars.whirlpooltimer = 0
		end
	
		// Set jump count to 1 and airchopping to false on the first frame.
		if (player.ssvars.springtimer == 0)
			player.ssvars.jmpcount = 1
			player.ssvars.airchopping = false
		end
	
		player.ssvars.springtimer = $+1
	else
		player.ssvars.springtimer = 0
	end
	
	// RAGING WHIRLPOOL // 
	if P_IsWhirlpooling(player) then

		local still_going = true
		
		// The timer has finished counting or we entered another state.
		if (player.ssvars.whirlpooltimer >= WHIRLPOOL_TIME)
		or (P_IsMovementLocked(player) and player.mo.state != S_PLAY_SPRING)
		or (P_IsButtBouncing(player))  then
			still_going = false
		end
	
		// Start spinning around!
		if (still_going) then
		
			local momz
			local speed
			local flipped
			
			speed = 8*FRACUNIT
			flipped = P_MobjFlip(player.mo) == -1
			
			momz = speed/10
		
			// If we're accelerating, boost the player forwards at their respective angle.
			if (P_GetPlayerControlDirection(player) > 0) then
				P_Thrust(player.mo, player.mo.angle, 2*FRACUNIT)
			end
		
			if (player.mo.state != S_PLAY_TWINSPIN) then
				player.mo.state = S_PLAY_TWINSPIN 
			end
			
			// For the first 35 tics, raise the player's Z momentum upwards.
			if (player.ssvars.whirlpooltimer < TICRATE) then
			
				local force = false
			
				// Force Z momentum based on whether the player is falling or not.
				if (flipped)
					force = player.mo.momz <= 0
				else
					force = player.mo.momz >= 0			
				end
				
				P_SetObjectMomZ(player.mo, momz, force)
			else 
				// After rising for 35 tics, make the player fall to a slow descent.
				if (flipped and player.mo.momz > 0) then
					P_SetObjectMomZ(player.mo, player.mo.momz/64, true)
				elseif (flipped != true and player.mo.momz < 0)
					P_SetObjectMomZ(player.mo, -player.mo.momz/64, true)
				end
			end
		else
			player.ssvars.whirlpooling = false // Quit the state early.
		end
		
		player.ssvars.whirlpooltimer = $ + 1 // Add to timer.
		
		return
	end

	// BUTTBOUNCE //
	if P_IsButtBouncing(player) then
		
		local floor
		local floorz
		local stop
		local bounced
		
		player.pflags = $|PF_JUMPSTASIS|PF_JUMPED // Prevent jumping during a buttbounce
		player.pflags = $ & ~PF_NOJUMPDAMAGE // Don't take damage during a buttbounce
		player.powers[pw_strong] = $|STR_SPRING // Springs give additional boost
		player.runspeed = INT32_MAX // hack to stop the player's ability to run on water
	
		// If the player is flipped, then flip the floor positions as well.
		if (P_MobjFlip(player.mo) == -1) then
			floor = player.mo.ceilingrover
			floorz = player.mo.ceilingz
		else
			floor = player.mo.floorrover
			floorz = player.mo.floorz
		end
		
		stop = false
		bounced = false
		
		// There's a FOF below us!
		if (floor and (floor.flags & FOF_EXISTS) and floor.valid) then
			// The player touched the floor / ceiling of a FOF.
			if (P_MobjFlip(player.mo) == 1 and player.mo.z <= floorz+USERANGE/2)
			or (P_MobjFlip(player.mo) == -1 and player.mo.z >= floorz+USERANGE/2) then	
				if (floor.flags & FOF_BUSTUP) then EV_CrumbleChain(nil, floor) end // Bustable FOF
				if (floor.flags & FOF_BOUNCY) or (floor.bouncestrength > 0) then bounced = true end // Bouncy FOF
			end
		end
	
		// The player hit the ground or touched a bouncy FOF.
		if (onground or bounced)
			stop = true
		end
		
		// The player is not butt-bouncing anymore.
		if (P_IsMovementLocked(player))
		or (P_PlayerTouchingSectorSpecial(player, 4, 5))
		or (player.mo.state == S_PLAY_FALL)
		or (player.mo.state == S_PLAY_SPRING)
		or (player.mo.state == S_PLAY_DEAD)
		or (player.pflags & PF_SHIELDABILITY)
			stop = true
		end
		
		if (stop) then 
			P_StopButtBounce(player, onground, bounced) 	
		end
		
		return
	end
	
	// ITEM TOSS //
	if (P_CanSpongeToss(player) and (player.cmd.buttons & BT_TOSSFLAG) and P_GetSSPowerupCount(player) > 0)
	
		local tbl = supersponge_powerup_info
	
		for i = 1, #tbl, 1 do
		
			// Ignore "inactive" pickups.
			if not P_IsPowerupActive(player, i) then continue end
		
			// Never drop the balloon until all other weapons have been dropped.
			if (P_GetSSPowerupCount(player, SS_TYPE_WEAPON) > 1 and i == SS_POWERUP_BALLOON) then continue end
			
			// Remove only weapons from the player's inventory.
			if (tbl[i] and tbl[i].type == SS_TYPE_GEAR) then continue end

			P_RemoveSSPowerup(player, i, true, false)
			
			break
		end
		
		player.tossdelay = SS_TOSS_COOLDOWN
	end
end
addHook("PlayerThink", SpongebobThink)


//////////////////////////////////////////
//             Actions                 //
////////////////////////////////////////


function A_SSPickupRespawn(actor, var1, var2)
	// If not respawning, just go to S_NULL.
	if not (actor.is_golden) then actor.state = S_NULL else actor.health = 1 actor.flags = MF_SPECIAL end
end

function A_SSPowerupThink(actor, var1, var2)
	
	local tbl
	
	tbl = supersponge_powerup_info
	
	if (actor.type != MT_SUPERSPONGE_POWERUP and actor.type != MT_SUPERSPONGE_PICKUP) then
		return
	end
	
	// default to the balloon
	if (actor.powerup == nil) then
		actor.powerup = SS_POWERUP_BALLOON
	end
	
	// To indicate respawning pickups, turn them "gold" and spawn sparkles around them.
	if (actor.is_golden) 
		// "All that glitters is gold."
		if (actor.color != SKINCOLOR_GOLD) then
			actor.color = SKINCOLOR_GOLD
			actor.colorized = true
		end
		// Deduct sparkle timer.
		if (actor.extravalue1) then
			actor.extravalue1 = $ - 1
		else
			actor.extravalue1 = 1
		end
		// After timer is over, spawn sparkles.
		if (actor.extravalue1 == 0) then
			A_GoldMonitorSparkle(actor)
		end
	end
	
	// If the powerup is currently not disappearing, use their respective sprite.
	if not (actor.fuse > 0 and actor.fuse <= 30 and actor.fuse & 2) then
		actor.sprite = tbl[actor.powerup].sprite or SPR_SSDI
	end
	
	// switch item frames visually depending on the ID
	if (tbl[actor.powerup] and tbl[actor.powerup].frame) then
		actor.frame = $|tbl[actor.powerup].frame
	end
end

function A_SSBlowerThink(actor, var1, var2)

	local sponge

	if not (actor.target and actor.target.valid) then
		return
	end
	
	sponge = actor.target.player or nil

	if not (sponge and sponge.valid and actor and actor.valid) then 
		return 
	end
	
	actor.angle = sponge.drawangle
	
	if not P_CanSpongeVacuum(sponge) then
		return
	end
	
	P_SpongeVacuumThink(actor) // Pull any nearby objects towards the player
end

function A_SpongeFakeMissileThink(actor, var1, var2)

	local deathstate
	local info

	if not (actor and actor.valid) then	
		return
	end	
	
	info = actor.extravalue3 and mobjinfo[actor.extravalue3] or nil // mobj's original info
	
	// Go to the respective type's deathstate
	if (actor.state == S_SUPERSPONGE_FAKEMISSILE_DEATH) then
	
		if (info == nil) then
			return // The original object type somehow disappeared?
		end
	
		actor.type = actor.extravalue3
		actor.flags = mobjinfo[actor.extravalue3].flags
		
		P_KillMobj(actor, nil, actor.target)
		
		return
	end	
	
	// Spin rollangle for non-missiles.
	if not (info and info.flags & MF_MISSILE)
		actor.rollangle = $ + ANGLE_22h
	end
	
	actor.sprite = actor.extravalue1 or SPR_NULL
end

function A_SpawnNetHitbox(actor, var1, var2)

	local x, y, z
	local sponge
	local angle
	local net
	local dummy
	local thrust
	local limit
	
	if not (actor.player and actor.player.valid) then
		return
	end
	
	sponge = actor.player
	angle = sponge.drawangle
	
	// No net, no jellyfish
	if not P_IsPowerupActive(sponge, SS_POWERUP_NET) then
		return
	end
	
	// we're firing, not catching
	if (sponge.ssvars.net.mode >= 1) then
	
		// Launch your projectile!
		if (actor.state == S_PLAY_SSNET2) then
			P_LaunchNetItem(sponge)
		end
	
		return
	end
	
	// The net is full.
	if (P_GetNetCount(sponge) >= supersponge_powerup_info[SS_POWERUP_NET].maxammo) then
		return
	end
	
	z = 0
	
	// Hitbox Positions
	if (var1 >= 2) // Forwards
		limit = FixedMul(actor.radius, actor.scale) + 16*FRACUNIT
	elseif (var1 == 1) // Diagonal
		limit = FixedMul(actor.radius, actor.scale) + 16*FRACUNIT
		z = FixedMul(actor.height, actor.scale)
	else //Upwards
		limit = FixedMul(actor.radius, actor.scale) + 16*FRACUNIT
		z = FixedMul(actor.height, actor.scale)
	end
	
	thrust = 0
	
	// Spawn a fake dummy with the size and flags
	dummy = P_SpawnMobjFromMobj(actor, 0, 0, 32*FRACUNIT, MT_RAY)
	dummy.flags = MF_NOGRAVITY|MF_SOLID|MF_NOCLIPTHING
	dummy.radius = mobjinfo[MT_SUPERSPONGE_NETBOX].radius/2
	dummy.height = mobjinfo[MT_SUPERSPONGE_NETBOX].height
	
	// Now check if the position is okay before moving.
	while (thrust < limit) do
	
		local x_thrust = P_ReturnThrustX(nil, angle, thrust)
		local y_thrust = P_ReturnThrustY(nil, angle, thrust)
	
		if not P_TryMove(dummy, actor.x + x_thrust, actor.y + y_thrust, true) then
			break
		end
	
		thrust = $ + FRACUNIT
	end
	
	// We got the coordinates, now move the net to it's new position.
	x = P_ReturnThrustX(nil, angle, thrust)
	y = P_ReturnThrustY(nil, angle, thrust)
	
	// Remove the dummy.
	P_RemoveMobj(dummy)
	
	// Spawn the jellyfishing net!
	net = P_SpawnMobjFromMobj(actor, x, y, z * P_MobjFlip(actor), MT_SUPERSPONGE_NETBOX)
	
	// By wearing the glasses, you get a wider hitbox!
	if (sponge.ssvars.powerups[SS_POWERUP_GLASSES]) then
		net.height = $ + 4*FRACUNIT
		net.radius = $ + 4*FRACUNIT
	end
	
	// Set target
	net.target = actor
	
	// Set active hitbox
	actor.player.ssvars.hitbox = net
end

function A_SpawnKarateHitbox(actor, var1, var2)

	local hmom
	local vmom
	local sponge
	local angle
	local glove
	
	if not (actor.player and actor.player.valid) then
		return
	end
	
	sponge = actor.player
	angle = sponge.drawangle
	
	// Hitbox Positions
	if (var1 >= 2) // Forwards
		hmom = 8*FRACUNIT
		vmom = 0
	elseif (var1 == 1) // Diagonal
		hmom = 8*FRACUNIT
		vmom = FixedMul(actor.height/2, actor.scale) + 16*FRACUNIT
	else //Upwards
		hmom = 0
		vmom = FixedMul(actor.height/2, actor.scale) + 16*FRACUNIT
	end
	
	// Spawn the karate hitbox.
	glove = P_SpawnMobjFromMobj(actor, 0, 0, 0, MT_SUPERSPONGE_KARATEBOX)
	
	// Thrust the glove forwards.
	P_InstaThrust(glove, angle, hmom)
	
	// Set the glove's z momentum.
	P_SetObjectMomZ(glove, vmom, false)
	
	// Set target
	glove.target = actor
	
	// Set active hitbox
	actor.player.ssvars.hitbox = glove
end

function A_SpawnBubblePlatform(actor, var1, var2)

	local x, y
	local sponge
	local net
	local bubble
	
	if not (actor.player and actor.player.valid) then
		return
	end
	
	sponge = actor.player
	
	x = P_ReturnThrustX(actor, sponge.drawangle, 64*FRACUNIT)
	y = P_ReturnThrustY(actor, sponge.drawangle, 64*FRACUNIT)
	
	// Decrement ammo
	sponge.ssvars.ammo["bubbles"] = $ - 1
	
	if (sponge.ssvars.ammo["bubbles"] <= 0) then
		sponge.ssvars.ammo["bubbles"] = 0 // because you never know
	end
	
	// Play sfx_bubwnd
	S_StartSound(actor, sfx_bubwnd, sponge)
	
	// Spawn platform
	bubble = P_SpawnMobjFromMobj(actor, x, y, 16*FRACUNIT, MT_SUPERSPONGE_BUBBLE)
	
	// Set fuse time
	bubble.fuse = 5*TICRATE
	
	// Set shooting cooldown
	sponge.ssvars.shoottimer = 8 
end

function A_VortexBubbleThink(actor, var1, var2)
	
	local x, y, z
	local angle = actor.angle
	local target = actor.target
	local remove = false
	
	if not (target and target.valid and target.player and P_IsWhirlpooling(target.player)) then
		remove = true
	end
	
	if (remove) then P_RemoveMobj(actor) return end
	
	P_PlayBubbleSound(actor) // play sfx
	
	if not (actor.extravalue1) then
		actor.extravalue1 = 0
	elseif (actor.extravalue1 >= 128*FRACUNIT) then
		actor.extravalue1 = 0
	end
	
	actor.extravalue1 = $ + 8*FRACUNIT

	// Move around a "center" point, mimicking the dust devils
	x = target.x + P_ReturnThrustX(actor, angle, 64*FRACUNIT)
	y = target.y + P_ReturnThrustY(actor, angle, 64*FRACUNIT)
	
	// Move upwards around our target
	if (P_MobjFlip(target) == -1) then
		z = target.z + target.height - actor.extravalue1
	else
		z = target.z + actor.extravalue1
	end
		
	P_MoveOrigin(actor, x, y, z)
	
	actor.angle = $ + ANG20/2
end

function A_ClamAttack(actor, var1, var2)

	local target
	local summoner
	local dist
	local height
	local attack
	local total_dist
	
	attack = true
	target = actor.target
	summoner = actor.summoner
	
	// If our summoner does not exist anymore, then fly off into the distance.
	if not (summoner.mo and summoner.mo.valid) then P_KillMobj(actor, nil, nil, nil) return end
	
	// Our new target has left the building.
	if (not (target and target.valid) or actor.cusval > 0) then
		actor.target = summoner.mo // set target back to summoner
		P_SetMobjStateNF(actor, S_SUPERSPONGE_CLAM_FLAP1) // go back to initial state
		return
	else
		// Check the distance away from your target
		dist = P_AproxDistance(target.x - actor.x, target.y - actor.y)
		height = target.z - actor.z
		total_dist = P_AproxDistance(dist, height)
		
		// If the total distance in all axes is greater than 128 fracunits...
		if (total_dist > CLAM_ATTACK_DIST) then
			actor.target = summoner.mo // set target back to summoner
			P_SetMobjStateNF(actor, S_SUPERSPONGE_CLAM_FLAP1) // go back to flying state
			return
		end
	end
	
	// Clamp at em!
	if P_CheckMeleeRange(actor) then
		P_DoClamAttack(actor, target)
	else
		A_HomingChase(actor, 16*FRACUNIT, 0)
	end
end

// Override A_FlickyFly to add enemy detection for clams.
function A_FlickyFly(actor, var1, var2)

	// Special handling for clam flicky.
	if (actor.type == MT_SUPERSPONGE_CLAM) then
	
		local enemy
		local summoner
		local dist
		
		summoner = actor.summoner
		
		// If your summoner has somehow disappeared, fly away.
		if not (summoner.mo and summoner.mo.valid and summoner.mo.health > 0) then actor.state = S_SUPERSPONGE_CLAM_SPIN return end

		dist = P_AproxDistance(summoner.mo.x - actor.x, summoner.mo.y - actor.y)
		
		// Our summoner is too far away from us!
		if (dist > CLAM_ATTACK_DIST) then
			actor.searching = true
		end
		
		// search mode
		if (actor.searching) then		
			return
		end
	
		enemy = P_ClamSearch(actor) // try searching for enemies
	
		// Did we find a valid enemy?
		if (enemy and enemy.valid and actor.target != enemy and not actor.cusval) then

			actor.target = enemy // Set target.
		
			P_SetMobjStateNF(actor, S_SUPERSPONGE_CLAM_ATTACK) // Attack the enemy.
		
			return
		end
	end

	super(actor, var1, var2)
end

function A_SpawnSpongeFakePlat(actor, var1, var2)

	local platmobj

	if not (actor and actor.valid) then
		return
	end
	
	// Let's try making a "platform"...wink wink
	platmobj = P_SpawnMobj(actor.x, actor.y, actor.z, MT_RAY)
	
	if not (platmobj and platmobj.valid) then
		return
	end
	
	// Set scale
	platmobj.scale = actor.scale
	
	// Set radius / height
	platmobj.height = actor.height
	platmobj.radius = actor.radius
	
	// Set target, flags, and state
	platmobj.target = actor // target the one who summoned us 
	platmobj.flags = MF_SOLID|MF_NOCLIPTHING // flags of plat
	platmobj.state = S_SUPERSPONGE_FAKEPLAT // state of the plat
	
	// Set momz
	platmobj.momz = 0
end


function A_SpongeFakePlatThink(actor, var1, var2)

	if not (actor and actor.valid) then
		return
	end
	
	// If we're not rising "relatively" then set to 0 to prevent constant movement.
	if not (var2) then
		actor.momz = 0
	end
	
	// Your target "platform" has disappeared, so remove yourself
	if (actor.target == nil or actor.target and actor.target.health <= 0) then
		P_RemoveMobj(actor)
		return
	end
	
	// Move platform upwards / downwards
	P_SetObjectMomZ(actor, var1, var2)
	
	// Set target position
	P_MoveOrigin(actor.target, actor.x, actor.y, actor.z)
end

function A_SuperSpongeShot(actor, var1, var2)
	
	local sponge
	local missile
	local target
	local amount
	local time
	
	if not (actor.player and actor.player.valid) then
		return
	end
	
	sponge = actor.player
	target = sponge.ssvars.lockon
	
	// Always prioritize launching the exploding pie first!
	if (sponge.ssvars.powerups[SS_POWERUP_PIE]) then
		return P_LaunchExplodingPie(sponge) 
	end
	
	// Shoot missile type depending on var1
	if (var1 >= 1) then
		missile = MT_SUPERSPONGE_BUBBLEMISSILE
	else
		missile = MT_SUPERSPONGE_JELLYMISSILE
	end
	
	// If the player is about to fire a triple shot, 
	if (sponge.ssvars.tripleshot and (sponge.ssvars.ammo["jellyfish"] - 3) > -1) then
		amount = 3		
	else
		amount = 1
	end
	
	// If the missile type is jellyfish missile, deduct ammo.
	if (missile == MT_SUPERSPONGE_JELLYMISSILE) then
		sponge.ssvars.ammo["jellyfish"] = $ - amount
	end
	
	if (sponge.ssvars.ammo["jellyfish"] < 0) then
		sponge.ssvars.ammo["jellyfish"] = 0
	end
	
	sponge.drawangle = actor.angle
	
	// If a target is present, lock angle to target and fire
	if (target and target.valid) then
		P_SpawnAimedMissile(actor, target, missile, amount)
	else
		local rocket = nil
		local angle = -8*FRACUNIT // Set initial angle for left missile.
	
		for i = 1, amount, 1 do
			
			if (amount == 1) then
				rocket = P_SpawnPlayerMissile(actor, missile)
			else
				rocket = P_SPMAngle(actor, missile, actor.angle+FixedAngle(angle), 1)
			end
			
			if not (rocket and rocket.valid) then
				continue
			end
			
			// Halve the bubble's scale and add MF2_SUPERFIRE.
			if (rocket.type == MT_SUPERSPONGE_BUBBLEMISSILE) then
				rocket.scale = 7*FRACUNIT/10
				rocket.flags = $|MF2_SUPERFIRE
			end
			
			angle = $ + 8*FRACUNIT // Increase angle for next missile.
		end
	end
	
	sponge.ssvars.shoottimer = var2
	sponge.ssvars.tripleshot = false
end

local function A_SSBalloonThink(actor, var1, var2)

	local point
	local dist
	local z
	local runspeed
	local sponge
	local target
	local isactive
	local angle

	if not (actor.target and actor.target.valid) then
		return P_RemoveMobj(actor)
	end
	
	target = actor.target
	sponge = actor.target.player
	isactive = P_IsPowerupActive(sponge, SS_POWERUP_BALLOON) and sponge.powers[pw_super] <= 0 and sponge.powers[pw_carry] != CR_NIGHTSMODE
	
	// If we no longer have the balloon or the player is not Spongebob, remove it.
	if (sponge and not (isactive and P_IsSuperSponge(target.skin)) or cv_powerups.value <= 0)
		return P_RemoveMobj(actor) // If powerups aren't active, don't show the balloon.
	end
	
	// Set angle depending on whether it's a player or a regular mobj
	if (target.player) then
		angle = target.player.drawangle
	else
		angle = target.angle
	end
	
	actor.angle = angle
	
	// Copy our target's flip
	if P_MobjFlip(target) == -1 then
		// Flip upside down
		if not (actor.eflags & MFE_VERTICALFLIP) then
			actor.eflags = $|MFE_VERTICALFLIP
		end
		z = (target.z - target.height) - 32*FRACUNIT
	else
		// Flip rightside up
		if (actor.eflags & MFE_VERTICALFLIP) then
			actor.eflags = $ & ~MFE_VERTICALFLIP
		end
		z = (target.z + target.height) + 32*FRACUNIT
	end
	
	// Spawn a "fake" chase point above the actor's head
	point = P_SpawnMobj(target.x + P_ReturnThrustX(target, angle, -4*FRACUNIT), 
						target.y + P_ReturnThrustY(target, angle, -4*FRACUNIT), 
						z, 
						MT_RAY)
	point.fuse = 2
	
	// Get the distance between our point and the balloon
	dist = P_AproxDistance(P_AproxDistance(point.x - actor.x, point.y - actor.y), point.z - actor.z)
	
	actor.tracer = point
		
	// Move the balloon based on speed
	P_MoveOrigin(actor, 
				 point.x + P_ReturnThrustX(target, angle, -target.player.speed), 
				 point.y + P_ReturnThrustY(target, angle, -target.player.speed), 
				 point.z
	)
	
	// "Draw" the string between your actor and target.
	R_DrawBalloonString(actor, target)
end

function A_CheckSpongeSkin(actor)

	local sponge
	local remove_overlay = false

	if not (actor.target and actor.target.valid) then 
		return
	end
	
	if not P_IsSuperSponge(actor.target.skin) then return end
	
	sponge = actor.target.player
	
	// Remove the overlay if the player no longer has the blower or the object does not match the target's blower.
	if (actor.state == S_SUPERSPONGE_BLOWER and not sponge.ssvars.powerups[SS_POWERUP_BLOWER])
	or (actor.state == S_SUPERSPONGE_HELMET and not sponge.ssvars.powerups[SS_POWERUP_SUIT] and not sponge.ssvars.powerups[SS_POWERUP_HELMET]) then 
		remove_overlay = true
	end
	
	if (remove_overlay and actor and actor.valid) then
		actor.state = S_NULL // remove the actor by setting their state to S_NULL
	end
end

// Because a similar function isn't exposed to lua...
local function P_DoRandomPickupChances()

	local spawnchance = {}
	local numchoices, i
	local key = P_RandomKey(10)
	
	numchoices = 0
	i = 0

	if (not(netgame or multiplayer))
		if (key == 0)
			return MT_RING_ICON
		elseif (key == 1)
			return MT_SNEAKERS_ICON
		elseif (key == 2)
			return MT_INVULN_ICON
		elseif (key == 3)
			return MT_WHIRLWIND_ICON
		elseif (key == 4)
			return MT_ELEMENTAL_ICON
		elseif (key == 5)
			return MT_ATTRACT_ICON
		elseif (key == 6)
			return MT_FORCE_ICON
		elseif (key == 7)
			return MT_ARMAGEDDON_ICON
		elseif (key == 8)
			return MT_1UP_ICON
		elseif (key == 9)
			return MT_EGGMAN_ICON
		end
		return MT_NULL
	end

	local QUESTIONBOXCHANCES = function(type, cvar)
		for i = cvar.value, i, -1 do 
			numchoices = $ + 1
			spawnchance[numchoices] = type
		end
	end
	
	// Release the kraken!
	QUESTIONBOXCHANCES(MT_RING_ICON, CV_FindVar("tv_superring"))
	QUESTIONBOXCHANCES(MT_SNEAKERS_ICON, CV_FindVar("tv_supersneaker"))
	QUESTIONBOXCHANCES(MT_INVULN_ICON, CV_FindVar("tv_invincibility"))
	QUESTIONBOXCHANCES(MT_WHIRLWIND_ICON, CV_FindVar("tv_jumpshield"))
	QUESTIONBOXCHANCES(MT_ELEMENTAL_ICON, CV_FindVar("tv_watershield"))
	QUESTIONBOXCHANCES(MT_ATTRACT_ICON, CV_FindVar("tv_ringshield"))
	QUESTIONBOXCHANCES(MT_FORCE_ICON, CV_FindVar("tv_forceshield"))
	QUESTIONBOXCHANCES(MT_ARMAGEDDON_ICON, CV_FindVar("tv_bombshield"))
	QUESTIONBOXCHANCES(MT_1UP_ICON, CV_FindVar("tv_1up"))
	QUESTIONBOXCHANCES(MT_EGGMAN_ICON, CV_FindVar("tv_eggman"))
	QUESTIONBOXCHANCES(MT_MIXUP_ICON, CV_FindVar("tv_teleporter"))
	QUESTIONBOXCHANCES(MT_RECYCLER_ICON, CV_FindVar("tv_recycler"))

	if (numchoices == 0) return MT_NULL end
	return spawnchance[P_RandomKey(numchoices)]
end

// On restore, respawn the pickup icon.
function A_GoldMonitorRestore(actor, var1, var2)

	super(actor, var1, var2) // Let's call the original action first!
	
	if not (actor.powerup) then return end // This monitor has no active powerups, so ignore it.
	
	DisplaySSPickupIcon(actor)
	
	// The powerup icon did not respawn correctly!
	if not (actor.tracer and actor.tracer.valid and actor.tracer.state == S_SUPERSPONGE_ICON1) then
		return
	end
	
	P_SetMobjStateNF(actor.tracer, S_SUPERSPONGE_ICON2)
end

// Yay! Hooray for repetition!
function A_GoldMonitorPop(actor, var1, var2)

	local item = 0
	local powerup = 0
	local newmobj = nil
	
	// Again, let other characters alter A_GoldMonitorPop as usual
	if not (actor.target and actor.target.player and P_IsSuperSponge(actor.target.skin) and cv_powerups.value > 0) then
		return super(actor, var1, var2)
	end

	// Spawn the "pop" explosion.
	if (actor.info.deathsound)
		S_StartSound(actor, actor.info.deathsound)
	end

	// Remove our flags for a bit.
	// Players can now stand on top of us.
	actor.flags = $ & ~(MF_MONITOR|MF_SHOOTABLE)
	
	// Don't count this box in statistics. Sorry.
	if (actor.target and actor.target.player)
		actor.target.player.numboxes = $ - 1
	end
	actor.fuse = 0 // Don't let the monitor code screw us up.

	if (actor.info.damage == MT_UNKNOWN)
		// MT_UNKNOWN is random. Because it's unknown to us... get it?
		item = P_DoRandomPickupChances()

		if (item == MT_NULL)
			return
		end
		
		powerup = supersponge_boxicon_table[item]
	else
		item = actor.info.damage
		powerup = actor.powerup
    end
	

	// Instead of dropping the powerup, golden monitors give it to the player instantly.
	if (powerup and P_PlayerCanGrabPowerup(actor.target.player, powerup)) then
		return P_GiveSSPowerup(actor.target.player, powerup, true)
	end

	// It spawns one fracunit higher? I never noticed.
	newmobj = P_SpawnMobjFromMobj(actor, 0, 0, 14*FRACUNIT, item)
	newmobj.target = actor.target // Transfer target
	
	if (item == MT_SUPERSPONGE_PICKUP)
		newmobj.powerup = powerup // assign pickup
		newmobj.fuse = 30*TICRATE // set fuse
	elseif (item == MT_1UP_ICON) then
		if (actor.tracer) // Remove the old lives icon.
			P_RemoveMobj(actor.tracer)
		end
		if (not newmobj.target
		or not newmobj.target.player
		or not newmobj.target.skin
		or skins[newmobj.target.skin].sprites[SPR2_LIFE].numframes == 0)
			 // No lives icon for this player, use the default
		else
			// Spawn the lives icon
			local livesico = P_SpawnMobjFromMobj(newmobj, 0, 0, 0, MT_OVERLAY)
			livesico.target = newmobj
			newmobj.tracer = livesico
			
			livesico.color = newmobj.target.player.mo.color
			livesico.skin = skins[newmobj.target.player.skin].name
			livesico.state = newmobj.info.seestate
			
			// We're using the overlay, so use the overlay 1up sprite (no text)
			newmobj.sprite = SPR_TV1P
		end
	end
end

function A_MonitorPop(actor, var1, var2)

	local item = 0
	local powerup = 0
	local newmobj = nil
	
	// Let everyone else alter A_MonitorPop as usual.
	if not (actor.target and actor.target.player and P_IsSuperSponge(actor.target.skin) and cv_powerups.value > 0) then
		return super(actor, var1, var2)
	end

	// Spawn the "pop" explosion.
	if (actor.info.deathsound)
		S_StartSound(actor, actor.info.deathsound)
	end
	P_SpawnMobjFromMobj(actor, 0, 0, actor.height/4, MT_EXPLODE)

	// We're dead now. De-solidify.
	actor.health = 0
	actor.flags = $ & ~MF_SOLID
	actor.flags = $|MF_NOCLIP

	if (actor.info.damage == MT_UNKNOWN)
		// MT_UNKNOWN is random. Because it's unknown to us... get it?
		item = P_DoRandomPickupChances()

		if (item == MT_NULL)
			return
		end
		
		powerup = supersponge_boxicon_table[item]
	else
		item = actor.info.damage
		powerup = actor.powerup
    end
	
	if (supersponge_boxicon_table[item]) then
		item = MT_SUPERSPONGE_PICKUP
	end

	newmobj = P_SpawnMobjFromMobj(actor, 0, 0, 13*FRACUNIT, item)
	newmobj.target = actor.target // Transfer target
	
	if (item == MT_SUPERSPONGE_PICKUP)
		newmobj.powerup = powerup // assign pickup
		newmobj.fuse = 30*TICRATE // set fuse
	elseif (item == MT_1UP_ICON) then
		if (actor.tracer) // Remove the old lives icon.
			P_RemoveMobj(actor.tracer)
		end
		if (not newmobj.target
		or not newmobj.target.player
		or not newmobj.target.skin
		or skins[newmobj.target.skin].sprites[SPR2_LIFE].numframes == 0)
			 // No lives icon for this player, use the default
		else
			// Spawn the lives icon
			local livesico = P_SpawnMobjFromMobj(newmobj, 0, 0, 0, MT_OVERLAY)
			livesico.target = newmobj
			newmobj.tracer = livesico
			
			livesico.color = newmobj.target.player.mo.color
			livesico.skin = skins[newmobj.target.player.skin].name
			livesico.state = newmobj.info.seestate
			
			// We're using the overlay, so use the overlay 1up sprite (no text)
			newmobj.sprite = SPR_TV1P
		end
	end
end

function A_PickupIconThink(actor, var1, var2)

	local tbl
	local pickup
	local closestplayer = -1
	local dist = INT32_MAX
	local display = false

	// Uh, where's our monitor?
	if not (actor.target and actor.target.valid and actor.target.health >  0) then
		return P_RemoveMobj(actor)
	end
	
	// All of Spongebob's powerups were turned off.
	if (actor.target.powerup and cv_powerups.value <= 0) then
		return 
	end
	
	// Not visible.
	if (actor.target.sprite == SPR_NULL) 
	or (actor.target.flags2 & MF2_DONTDRAW) 
	or (actor.target.state == S_INVISIBLE) then
		return
	end

	pickup = BoxHasSuperSpongeIcon(actor.target) and 1024 or actor.target.powerup // Get the respective powerup from the monitor.

	if (multiplayer) then
		// boy doesn't this look familiar!
		for i = 0, 31, 1
		
			local temp
		
			if (not (players[i] and players[i].valid) or players[i].bot == BOT_2PAI or players[i].bot == BOT_2PHUMAN or players[i].spectator)
				continue
			end

			if not (players[i].mo)
				continue
			end

			if ((netgame or multiplayer) and players[i].playerstate != PST_LIVE)
				continue
			end

			temp = P_AproxDistance(players[i].mo.x-actor.x, players[i].mo.y-actor.y)

			if (temp < dist and P_IsSuperSponge(players[i].mo.skin))
				closestplayer = i
				dist = temp
				display = true
			end
		end
		if (closestplayer == -1)
			// Closest player not found (no players in game?? may be empty dedicated server!), or does not have correct sprite.
			return
		end
	else	
		if (consoleplayer and consoleplayer.valid and P_IsSuperSponge(consoleplayer.skin)) then
			display = true
		end
	end

	if not (display and pickup) then
		return 	// The player is currently playing as Spongebob in Singleplayer or the "closest" player is not Spongebob.
	end
	
	if (actor.target.is_golden) then
		actor.spriteyoffset = 2*FRACUNIT
	else
		actor.spriteyoffset = 0
	end
	
	// Only display the icon on the first frame of the monitor - aka - the non-blinking frame.
	if (actor.state != S_SUPERSPONGE_ICON2)
	
		local sprite = 0
		local frame = 0
		local is_ring_monitor = IsRingMonitor(actor.target)
		local is_sneaker_monitor = (actor.target.type == MT_SNEAKERS_BOX or actor.target.type == MT_SNEAKERS_GOLDBOX)
		
		// Select the respective frame to display from internal list
		if (supersponge_boxsprites_table[pickup]) then
			sprite = supersponge_boxsprites_table[pickup].sprite
			frame = supersponge_boxsprites_table[pickup].frame
		elseif (is_ring_monitor and not multiplayer) then
			sprite = SPR_SSD5
			frame = K
		elseif (is_sneaker_monitor and not multiplayer)
			sprite = SPR_SSD5
			frame = O
		end
		
		if not (sprite) then
			return // do not display sprite
		end
		
		actor.sprite = sprite
		actor.frame = frame
	end
end

// A simple function that calls the Armageddon Shield explosion
function A_ItWasMadeInABombFactory(actor, var1, var2)

	local player = actor.target.player

	if not (actor.target and actor.target.valid and actor.target.player) then
		return // it's a dud?
	end
	
	S_StartSound (actor, sfx_bkpoof) // Sound the BANG!

	for i = 0, 31, 1 do
		if (players[i] and players[i].valid and players[i].mo and players[i].mo.valid and P_AproxDistance(actor.x - players[i].mo.x,
			actor.y - players[i].mo.y) < 1536*FRACUNIT) then
			P_FlashPal(players[i], PAL_NUKE, 10)
		end
	end

	P_NukeEnemies(actor, player.mo, 1536*FRACUNIT) // Search for all nearby enemies and nuke their pants off!
end

function A_MyPlanetNeedsMe(actor, var1, var2)

	local momz

	if not (actor and actor.valid)
		return // where did he go
	end
	
	// Stay in place.
	actor.momx = 0
	actor.momy = 0
	
	// Check our timer to see how long we've been spinning.
	if (actor.extravalue3) then 
		actor.extravalue3 = $ - 1
		if (actor.extravalue3 == 1) then
			return P_RemoveMobj(actor) // we're done here!
		end
	else
		actor.extravalue3 = TICRATE
		actor.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
	end

	actor.angle = $ + ANGLE_45 // rotate actor angle by 45
	
	// Fly actor upwards / downwards depending on gravity
	if (P_MobjFlip(actor) == -1) then
		momz = -FRACUNIT
	else
		momz = FRACUNIT
	end
	
	P_SetObjectMomZ(actor, momz, true)
end

function A_SignpostPantsThinker(actor, var1, var2)

	local signface = actor.target

	if not (actor.target and actor.target.valid) then
		return
	end

	actor.angle = signface.angle
end

function A_BubbleTrailer(actor)
	
	local th
	local thtype
	
	thtype = MT_SUPERSPONGE_BUBBLEPARTICLE

	// add the bubble behind the rocket
	if (actor.eflags & MFE_VERTICALFLIP) then
		th = P_SpawnMobj(actor.x-actor.momx, 
						 actor.y-actor.momy, 
						 actor.z + actor.height - FixedMul(mobjinfo[thtype].height, actor.scale), thtype)
		th.flags2 = $|MF2_OBJECTFLIP
	else
		th = P_SpawnMobj(actor.x-actor.momx, actor.y-actor.momy, actor.z, thtype)
	end
	
	th.colorized = true
	th.color = SKINCOLOR_BLUE
	
	// set scale
	th.destscale = actor.scale
	P_SetScale(th, actor.scale)
	
	// set fuse
	th.fuse = TICRATE/2
end

// Thanks to Katmint for their Character-specific Jingles example
addHook("MusicChange", function(oldname, newname)
	if (consoleplayer and consoleplayer.valid)
	
		local character = skins[consoleplayer.skin].name
		local track = supersponge_jingles[newname] != nil and supersponge_jingles[newname] or nil
	
		if (cv_supersponge_jingles.value <= 0) then 
			return // Jingles are turned off
		end

		if not P_IsSuperSponge(character) then 
			return // Not Spongebob.
		end
		
		if not (track) then 
			return // The track is missing
		end
		
		return track
	end
end)

// Hurt message stuff
addHook("HurtMsg", function(sponge, inflictor, source, damagetype)

	local message
	local supersponge
	
	// Death messages only
	if (sponge.mo.health > 0) then
		return
	end
	
	message = nil
	supersponge = P_IsSuperSponge(sponge.mo.skin)
	
	if (inflictor and inflictor.valid and source and source.valid) then
		// "I got you now, Spongebob!"
		if (inflictor.type == MT_SUPERSPONGE_NETBOX) then
			message = ("%s caught %s in their jellyfishing net.\n"):format(source.player.name, sponge.name)
		end
		// The player was killed by a flying jellyfish.
		if (inflictor.type == MT_SUPERSPONGE_JELLYMISSILE) then
			message = ("%s's flying jellyfish killed %s.\n"):format(source.player.name, sponge.name)
		end
		// The player was killed by a bubble shot.
		if (inflictor.type == MT_SUPERSPONGE_BUBBLEMISSILE) then
			message = ("%s's thrown bubble killed %s.\n"):format(source.player.name, sponge.name)
		end
	end

	// DMG_INSTAKILL cannot be combined with DMG_FIRE, we'll have to do this the hard way.
	if (supersponge and sponge.mo.was_killed_by_lava and damagetype == DMG_INSTAKILL) then
		message = ("%s was killed by molten lava.\n"):format(sponge.name)
	end
	
	if not (message) then
		return // no message to override
	end
	
	return true
end)


//////////////////////////////////////////
//            Powerup Actions          //
////////////////////////////////////////


rawset(_G, "SB_BlowerAction", function(sponge)

	if (sponge.cmd.buttons & BT_ATTACK) then
		return // firing
	end

	if not P_CanSpongeVacuum(sponge)
		return // cannot vacuum
	end
	
	P_UseReefBlower(sponge)
end)

rawset(_G, "SB_NetAction", function(sponge)

	if (sponge.pflags & PF_SPINDOWN) then
		return // holding spin
	end
	
	if (sponge.cmd.buttons & BT_ATTACK) then 
		return // holding fire
	end

	if not P_CanSpongeJellyfish(sponge) then
		return // cannot jellyfish
	end
	
	P_UseJellyfishNet(sponge)
end)

rawset(_G, "SB_LauncherAction", function(sponge)

	local mo
	local sound
	local player
	
	mo = sponge.mo

	if (sponge.ssvars.ammo["jellyfish"] > 0 and sponge.ssvars.spinbtntimer == SS_LAUNCHER_MAX_TIME) then
		sound = sfx_cdfm40 // notify the player that the launcher is at max power
	elseif (sponge.ssvars.ammo["jellyfish"] <= 0 and not (sponge.pflags & PF_SPINDOWN) and not S_SoundPlaying(sponge.mo, sfx_s3k9a)) then
		sound = sfx_s3k9a // make click noise if no ammo.
	end	
	
	if not (sound) then
		return // no sound to play
	end
	
	if (sound == sfx_cdfm40) then
		player = sponge // play sound for player only
	end

	S_StartSound(mo, sound, player)
end)

rawset(_G, "SB_WandAction", function(sponge) 

	if (sponge.ssvars.ammo["bubbles"] <= 0) then
		return false // out of ammo
	end

	if P_CanBlowBubbles(sponge) then
		sponge.mo.state = S_PLAY_SSWAND // Blow bubbles.	
	end
	
	return true
end)

rawset(_G, "SB_PieAction", function(sponge)

	if (sponge.cmd.buttons & BT_ATTACK) and P_CanPieToss(sponge)
		return
	end
	
	sponge.mo.state = S_PLAY_SSF2RE
end)

rawset(_G, "SB_SuperAction", function(sponge)

	local inair = P_IsInJumpState(sponge) or sponge.mo.momz < 0
	local onground = P_IsObjectOnGround(sponge.mo)

	if (sponge.pflags & PF_SPINDOWN)
		return // holding spin
	end
	
	 // In your super form, perform the Raging Whirlpool while in the air.
	if (P_CanWhirlpool(sponge) and inair and not onground) then
	
		P_ActivateRagingWhirlpool(sponge)
		
		return
	end
		
	// We're whirlpooling or the shooting cooldown is still active or we're not on the ground.
	if (P_IsWhirlpooling(sponge) or sponge.ssvars.shoottimer > 0 or not onground) then
		return
	end
	
	sponge.mo.state = S_PLAY_SSF2RE // Shoot water balls.
	
	return
end)


//////////////////////////////////////////
//             States                  //
////////////////////////////////////////


states[S_PLAY_SSBNCE] = {SPR_PLAY, SPR2_BNCE|FF_SPR2ENDSTATE, 1, A_Null, S_PLAY_SSBNCE_END, 0, S_PLAY_SSBNCE}
states[S_PLAY_SSBNCE_END] = {SPR_PLAY, SPR2_BNCE, 1, A_Null, 0, 0, S_PLAY_SSBNCE_END}
states[S_PLAY_SSCHOP] = {SPR_PLAY, SPR2_MLEE, 2, A_SpawnKarateHitbox, 0, 0, S_PLAY_SSCHOP2}
states[S_PLAY_SSCHOP2] = {SPR_PLAY, SPR2_MLEE, 2, A_SpawnKarateHitbox, 1, 0, S_PLAY_SSCHOP3}
states[S_PLAY_SSCHOP3] = {SPR_PLAY, SPR2_MLEE, 2, A_SpawnKarateHitbox, 2, 0, S_PLAY_SSCHOP4}
states[S_PLAY_SSCHOP4] = {SPR_PLAY, SPR2_MLEL, 2, A_SpawnKarateHitbox, 3, 0, S_PLAY_SSCHOP5}
states[S_PLAY_SSCHOP5] = {SPR_PLAY, SPR2_MLEL, 2, A_SpawnKarateHitbox, 3, 0, S_PLAY_FALL}
states[S_PLAY_SSNET] = {SPR_PLAY, SPR2_JNET, 2, A_SpawnNetHitbox, 2, 0, S_PLAY_SSNET2} // Up
states[S_PLAY_SSNET2] = {SPR_PLAY, SPR2_JNET, 2, A_SpawnNetHitbox, 2, 0, S_PLAY_SSNET3} // Diagonal
states[S_PLAY_SSNET3] = {SPR_PLAY, SPR2_JNET, 2, A_SpawnNetHitbox, 2, 0, S_PLAY_SSNET4} // Forwards
states[S_PLAY_SSNET4] = {SPR_PLAY, SPR2_JNET, 2, A_SpawnNetHitbox, 8, 0, S_PLAY_FALL} // End
states[S_PLAY_SSWAND] = {SPR_PLAY, SPR2_BWND, 2, A_Null, 0, 0, S_PLAY_SSWAND2}
states[S_PLAY_SSWAND2] = {SPR_PLAY, SPR2_BWND, 2, A_Null, 1, 0, S_PLAY_SSWAND3}
states[S_PLAY_SSWAND3] = {SPR_PLAY, SPR2_BWND, 2, A_Null, 2, 0, S_PLAY_SSWAND4}
states[S_PLAY_SSWAND4] = {SPR_PLAY, SPR2_BWND, 4, A_SpawnBubblePlatform, 2, 0, S_PLAY_FALL}
states[S_PLAY_SSGUN] = {SPR_PLAY, SPR2_FIRE, 2, A_Null, 0, 0, S_PLAY_SSGUN2}
states[S_PLAY_SSGUN2] = {SPR_PLAY, SPR2_FIRE, 2, A_SuperSpongeShot, 0, SS_LAUNCHER_COOLDOWN, S_PLAY_SSGUN3}
states[S_PLAY_SSGUN3] = {SPR_PLAY, SPR2_FIRE|FF_SPR2ENDSTATE, 1, A_Null, S_PLAY_STND, 0, S_PLAY_SSGUN3}
//states[S_PLAY_SSGUN4] = {SPR_PLAY, SPR2_FIRE, 4, A_Null, 2, 0, S_PLAY_FALL}
states[S_PLAY_SSF2RE] = {SPR_PLAY, SPR2_F2RE, 2, A_Null, 0, 0, S_PLAY_SSF2RE2}
states[S_PLAY_SSF2RE2] = {SPR_PLAY, SPR2_F2RE, 2, A_SuperSpongeShot, 1, SS_LAUNCHER_COOLDOWN-2, S_PLAY_SSF2RE3}
states[S_PLAY_SSF2RE3] = {SPR_PLAY, SPR2_F2RE|FF_SPR2ENDSTATE, 2, A_Null, S_PLAY_STND, 0, S_PLAY_SSF2RE3}
//states[S_PLAY_SSF2RE4] = {SPR_PLAY, SPR2_F2RE, 4, A_Null, 2, 0, S_PLAY_FALL}
states[S_PLAY_MZAP] = {SPR_PLAY, SPR2_MZAP, 2, A_Null, 2, 0, S_PLAY_FALL}
states[S_PLAY_DRWN_END] = {SPR_PLAY, SPR2_DRWN|FF_ANIMATE, -1, A_Null, 0, 4, S_NULL}
states[S_PLAY_WALK_BLOWER] = {SPR_PLAY, SPR2_W3LK|FF_ANIMATE, 2, A_Null, 0, 6, S_PLAY_WALK_BLOWER}
states[S_PLAY_KRAB] = {SPR_PLAY, SPR2_KRAB|FF_ANIMATE, 2, A_Null, 0, 0, S_PLAY_KRAB}
// Object States
states[S_SUPERSPONGE_POWERUP] = {SPR_NULL, A, 2, A_SSPowerupThink, 0, 0, S_SUPERSPONGE_POWERUP} // Powerup
states[S_SUPERSPONGE_PICKUP] = {SPR_NULL, A, 2, A_SSPowerupThink, 0, 0, S_SUPERSPONGE_PICKUP} // Powerup Pickup
states[S_SUPERSPONGE_PICKUP_RESPAWN] = {SPR_NULL, A, 89, A_SSPickupRespawn, 0, 0, S_SUPERSPONGE_PICKUP} // Powerup Pickup (Respawning)
states[S_SUPERSPONGE_BALLOON] = {SPR_SSDI, A, 1, A_SSBalloonThink, 0, 0, S_SUPERSPONGE_BALLOON} // Balloon
states[S_SUPERSPONGE_BALLOON_POP] = {SPR_SSD4, A, 4, A_Scream, 0, 0, S_SUPERSPONGE_BALLOON_POP2} // Balloon (Popped)
states[S_SUPERSPONGE_BALLOON_POP2] = {SPR_NULL, A, 8, A_Null, 0, 0, S_NULL} // Balloon (Popped)
states[S_SUPERSPONGE_STRING] = {SPR_THOK, A|FF_PAPERSPRITE, 2, A_CheckBuddy, 0, 0, S_SUPERSPONGE_STRING} // Balloon (String)
states[S_SUPERSPONGE_VACBOX] = {SPR_NULL, A, 1, A_SSBlowerThink, 0, 0, S_SUPERSPONGE_VACBOX} // Vacuum Hitbox
states[S_SUPERSPONGE_PARTICLE] = {SPR_PRTL, A, 1, A_SSVacuumParticleThink, 0, 0, S_SUPERSPONGE_PARTICLE} // Vacuum Particles
states[S_SUPERSPONGE_HITBOX] = {SPR_NULL, A, 2, A_Null, 0, 0, S_NULL} // Net Hitbox
states[S_SUPERSPONGE_FAKEMISSILE] = {SPR_THOK, A, 1, A_SpongeFakeMissileThink, 0, 0, S_SUPERSPONGE_FAKEMISSILE} // Fake Object Missile
states[S_SUPERSPONGE_FAKEMISSILE_DEATH] = {SPR_THOK, A, 1, A_SpongeFakeMissileThink, 0, 0, S_NULL} // Fake Object Missile Death
states[S_SUPERSPONGE_JELLYMISSILE] = {SPR_SSD2, A, 1, A_Null, 0, 0, S_SUPERSPONGE_JELLYMISSILE} // Jellyfish Missile
states[S_SUPERSPONGE_BUBBLEMISSILE] = {SPR_SSD2, B, 4, A_BubbleTrailer, 0, 0, S_SUPERSPONGE_BUBBLEMISSILE} // Water Ball Missile
states[S_SUPERSPONGE_BUBBLEMISSILE_SPLASH] = {SPR_NULL, A, TICRATE, A_Null, 0, 0, S_NULL} // Water Ball Missile Death
states[S_SUPERSPONGE_BUBBLE] = {SPR_BUBL, E, 1, A_Null, 0, 0, S_SUPERSPONGE_BUBBLE} // Bubble Platform
states[S_SUPERSPONGE_BUBBLE_INIT] = {SPR_NULL, A, 1, A_SpawnSpongeFakePlat, 0, 0, S_SUPERSPONGE_BUBBLE} // Bubble Platform Init
states[S_SUPERSPONGE_FAKEPLAT] = {SPR_NULL, A, 1, A_SpongeFakePlatThink, FRACUNIT, 0, S_SUPERSPONGE_FAKEPLAT} // Fake Platform Thing
states[S_SUPERSPONGE_VORTEXBUBBLE] = {SPR_BUBL, B, 1, A_VortexBubbleThink, 0, 0, S_SUPERSPONGE_VORTEXBUBBLE} // Raging Whirlpool
states[S_SUPERSPONGE_CLAM_OUT] = {SPR_CL4M, A, 2, A_FlickyCheck, S_SUPERSPONGE_CLAM_FLAP1, S_SUPERSPONGE_CLAM_FLAP2, S_SUPERSPONGE_CLAM_OUT} // Clam Out
states[S_SUPERSPONGE_CLAM_FLAP1] = {SPR_CL4M, A, 3, A_FlickyFly,  8*FRACUNIT, 64*FRACUNIT, S_SUPERSPONGE_CLAM_FLAP2} // Clam Fly 1
states[S_SUPERSPONGE_CLAM_FLAP2] = {SPR_CL4M, A, 3, A_FlickyFly, 8*FRACUNIT, 64*FRACUNIT, S_SUPERSPONGE_CLAM_FLAP1} // Clam Fly 2
states[S_SUPERSPONGE_CLAM_STAND] = {SPR_CL4M, A, -1, A_Null, 2, 3, S_NULL} // Clam Standing
states[S_SUPERSPONGE_CLAM_CENTER] = {SPR_NULL, A, 15, A_FlickyCenter, MT_SUPERSPONGE_CLAM, 384*FRACUNIT, S_SUPERSPONGE_CLAM_CENTER} // Clam Center
states[S_SUPERSPONGE_CLAM_ATTACK] = {SPR_CL4M, B, 1, A_ClamAttack, 0, 0, S_SUPERSPONGE_CLAM_ATTACK} // Clam Attacking
states[S_SUPERSPONGE_CLAM_SPIN] = {SPR_CL4M, C, 1, A_MyPlanetNeedsMe, 0, 0, S_SUPERSPONGE_CLAM_SPIN} // Clam Flying Away
states[S_SUPERSPONGE_SHRINKRAY] = {SPR_SHCK, FF_PAPERSPRITE|A, 2, A_Null, 0, 0, S_NULL} // Shrink Ray
states[S_SUPERSPONGE_PANTS] = {SPR_NULL, A, 1, A_CheckSpongeSkin, 0, 0, S_SUPERSPONGE_PANTS} // Pants Overlay
states[S_SUPERSPONGE_BLOWER] = {SPR_NULL, A, 1, A_CheckSpongeSkin, 0, -48, S_SUPERSPONGE_BLOWER} // Blower Overlay
states[S_SUPERSPONGE_HELMET] = {SPR_NULL, A, 1, A_CheckSpongeSkin, 0, 0, S_SUPERSPONGE_HELMET} // Space helmet Overlay
states[S_SUPERSPONGE_SPATULA] = {SPR_SSD1, C, -1, A_Null, 0, 0, S_NULL} // Spatula Item
states[S_SUPERSPONGE_TOKEN] = {SPR_SSD1, D, -1, A_Null, 0, 0, S_NULL} // Token Item
states[S_SUPERSPONGE_SPRK] = {SPR_NULL, A, 14, A_Null, 0, 0, S_NULL} // Spatula Collected
states[S_SUPERSPONGE_ICON1] = {SPR_NULL, A, 2, A_PickupIconThink, 0, 14, S_SUPERSPONGE_ICON2} // Pickup Icon 
states[S_SUPERSPONGE_ICON2] = {SPR_NULL, A, 1, A_PickupIconThink, 0, 14, S_SUPERSPONGE_ICON1} // Pickup Icon (Blink)
states[S_SUPERSPONGE_PIE] = {SPR_SSD2, C|FF_ANIMATE, 16, A_Null, J, 2, S_SUPERSPONGE_PIE} // Exploding Pie
states[S_SUPERSPONGE_PIE_EXPLOSION] = {SPR_NULL, C|FF_ANIMATE, 2*TICRATE, A_ItWasMadeInABombFactory, J, 2, S_NULL} // Exploding Pie
states[S_SUPERSPONGE_FAKEBUBBLE] = {SPR_BUBL, A,  1, A_BubbleRise, 0, 1024, S_SUPERSPONGE_FAKEBUBBLE} // Fake Bubble
states[S_SUPERSPONGE_FAKEBUBBLE_MEDIUM] = {SPR_BUBL, B,  1, A_BubbleRise, 0, 1024, S_SUPERSPONGE_FAKEBUBBLE_MEDIUM} // Fake Bubble (Medium)
states[S_SUPERSPONGE_SPATULA_ICON1] = {SPR_SSD5, FF_ANIMATE|K,  18, A_Null, 3, 4, S_SUPERSPONGE_SPATULA_ICON2} // Spatula Icon
states[S_SUPERSPONGE_SPATULA_ICON2] = {SPR_SSD5, K, 18, A_RingBox, 0, 0, S_NULL} // Spatula Icon 2
states[S_SUPERSPONGE_QUICKSTER_ICON1] = {SPR_SSD5, FF_ANIMATE|O,  18, A_Null, 3, 4, S_SUPERSPONGE_QUICKSTER_ICON2} // Quickster Icon
states[S_SUPERSPONGE_QUICKSTER_ICON2] = {SPR_SSD5, O, 18, A_SuperSneakers, 0, 0, S_NULL} // Quickster Icon 2
states[S_SUPERSPONGE_SIGNPOST_OVERLAY] = {SPR_SSD4, FF_PAPERSPRITE|D, -1, A_SignpostPantsThinker, 0, 0, S_NULL} // Signpost Pants Overlay